
SECTION(1, Tutorial 1)

m4_define([WEBSITE],<a href="$1">$1</a>)
m4_define([REDB],<span class="red">BO($*)</span>)

m5_question([BO(Question 1.1: Some code to get you started.)  First,
please visit the
following <a href="m4_home/J.T.W/download-links.html">link</a> for the
programs that you need to have installed before you can do any coding
in J.T.W.  You should then download a tarball (also known as a
EM(compressed archive file)):
WEBSITE(http://davinpearson.nz/binaries/java-training-wheels.tar.gz)
containing the code you need to get started. Then unzip the tarball
and change directory to TT(java-training-wheels) and issue the
following command: TT(bash configure).  If you are using
EM(M.S. Windows) and your TT(HOME) variable is unset, then you will
need to set it to a sensible value.  Examples of sensible values for
your TT(HOME) variable include, TT(c:\) or TT(c:\home) or TT(d:\home)
if your TT(d) drive is a hard drive.  To set the TT(HOME) variable in
windows, press REDB(Windows E) and right click on EM(My Computer)
(Windows XP) or EM(This Computer) (Windows 10) and click on
EM(Properties), then click on EM(Advanced system settings), then click
on EM(Advanced), then click on EM(New) environment variable to set the
TT(HOME) variable.

</p>
<p align=justify>

When you run the TT(configure) script using the command TT(bash
configure) and you will be prompted for the location of prefix
directory and the location of the place to keep your TT(*.jtw) files.
You will also be asked if you want to install just EM(APOS(Davin)s
TT(jtw-mode)) or EM(APOS(Davin)s Full Version of GNU Emacs).  The
advantage of installing APOS(Davin)s Full Version of GNU Emacs is that
it has been extensively modified for optimum editing of code in many
different languages.  See the
following <a href="m4_home/J.T.W/how-to-use-emacs.html">link</a>.  To
install J.T.W. using the default settings, you need to issue the
following command: TT(yes | bash configure), assuming you have the
command TT(yes) installed as will be the case if you are using
GNU/Linux or Cygwin (WEBSITE(www.cygwin.com)).  Note that under the
default settings, APOS(Davin)s Full Version of GNU Emacs is BO(not)
extracted.

</p>
])
<p align=justify>

m4_ifdef([m5_is_questions],[REDB(NOTE:) If are reading this file on your
local filesystem then you would have already completed this
question.])

</p>

m5_question([BO(Question 1.2: Your first J.T.W. program.)
Traditionally in computer science the first program that you write in
any programming language is a program that does nothing else but
prints out TT("COMMA(Hello) World").  The following code does just
that.  In order to compile and run the following program you will need
use the EM(copy) feature of your web browser and the EM(paste) feature
of your text editor (which I hope for your sake is Davin's version of
GNU Emacs or GNU Emacs with Davin's TT(jtw-mode)) to bring the
following program code out of the J.T.W. web page and into your text
editor for editing purposes.  Once you have copied and pasted your
code you can then compile and run it.  Every other question in these
tutorial requires you to be familiar with the copy and paste operation
unless you are a masochist and like to type in your source code by
hand. In the following code, note the use of the CLASS construct. In
J.T.W. and Java, every piece of program code that does some real
computational work resides in a CLASS of some description.

m4_begin_indent
NU()CLASS CLSS(MyFirstProgram) EOL
BEGIN EOL
PD BEGINMAIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("COMMA(Hello) World!")); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

The code for any CLASS CLSS(X) in these tutorials should reside in a
file called TT(X.jtw).  Therefore the above code should be put into a
file called TT(MyFirstProgram.jtw).  If two classes CLSS(X) and
CLSS(Y) use each other and CLSS(X) contains the MAIN FUNCTION then it
is convenient to place them both in a file called TT(X.jtw).  To build
and run some code, you first need to be in the TT(~/jtw-tutorials)
folder and secondly you need to issue the following shell command:
TT(make clean GRN(X.run)) where CLSS(X) is the name of the CLASS that you
want to run, so it is

m4_begin_center
TT(make clean GRN(MyFirstProgram.run))
m4_end_center

in this case.  For all questions that follow this one, it will be
assumed that you know how to do this.  See SECT_BUILD for more
information about how to build collections of classes and entire
packages.])

m4_define(QEST_MULTIPLE,1.3)

m5_question([BO(Question 1.3: Multiple calls to
TT(System.out.println).)  Change the above code from printing the
string TT(STRI("[COMMA(Hello) World!]")) to printing out the following
messages.  Please note that it will be easiest to use multiple calls
to SYSTEM_OUT_PRINTLN which sends text to the screen for the purpose
of viewing.

m4_begin_indent
NI()Hello, Anne! How are you doing? EOL
Hello, Brian! How are you doing? EOL
Hello, Clare! How are you doing? EOL
m4_end_indent

])

m6_answer([BO(Answer 1.3:)

m4_begin_indent
NI()BEGINMAIN EOL
PD SYSTEM_OUT_PRINTLN(STRI("COMMA(Hello) Anne! How are you doing?")); EOL
PD SYSTEM_OUT_PRINTLN(STRI("COMMA(Hello) Brian! How are you doing?")); EOL
PD SYSTEM_OUT_PRINTLN(STRI("COMMA(Hello) Clare! How are you doing?")); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO([Question 1.4: Functions, parameters and arguments.])
A FUNCTION is a piece of code that does some computational work and
optionally returns a value.  Notice how the TT(hello) FUNCTION below
takes a value of whose name to say hello to.  This value TT(who) is
called a EM(parameter).  The values passed to the parameter by the
call to the FUNCTION is called an EM(argument).  For the purposes of
this question, add two more calls to the TT(hello) FUNCTION in the
MAIN FUNCTION to get the same result as the code for the previous
question.  The keyword EM(void) indicates that this FUNCTION does not
return a value.  See the next question for a FUNCTION that does return
a value.

m4_begin_indent
NI()CLASS CLSS(MySecondProgram) EOL
BEGIN EOL
PD FUNCTION VOID FUNC(hello)(STRING VARI(who)) EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Hello ") + who + STRI("COMMA() how are you doing?")); EOL
PD END EOL
PD BEGINMAIN EOL
PD PD hello(STRI("Anne")); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

])

m6_answer([BO(Answer 1.4:)

m4_begin_indent
NI()BEGINMAIN EOL
PD hello(STRI("Anne")); EOL
PD hello(STRI("Brian")); EOL
PD hello(STRI("Clare")); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 1.5: Return values.)  Notice how the
following TT(hello) FUNCTION returns a string rather than printing out
the string.  Add two more calls to the TT(hello) FUNCTION below to get
the same result as for Question QEST_MULTIPLE.

m4_begin_indent
NI()CLASS CLSS(MyThirdProgram) EOL
BEGIN EOL
PD FUNCTION STRING FUNC(hello)(STRING VARI(who)) EOL
PD BEGIN EOL
PD PD RETURN STRI("Hello ") + who + STRI("COMMA() how are you doing?"); EOL
PD END EOL
PD BEGINMAIN EOL
PD PD SYSTEM_OUT_PRINTLN(hello(STRI("Anne"))); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

])

m6_answer([BO(Answer 1.5:)

m4_begin_indent
NI()BEGINMAIN EOL
PD SYSTEM_OUT_PRINTLN(hello(STRI("Anne"))); EOL
PD SYSTEM_OUT_PRINTLN(hello(STRI("Brian"))); EOL
PD SYSTEM_OUT_PRINTLN(hello(STRI("Clare"))); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 1.6: Ignoring return values.)  In J.T.W. and
Java, it is not necessary to use a value that is returned by a
FUNCTION.  Sometimes this wastes computational resources since the
value that is computed by the FUNCTION is not used but other times
when the FUNCTION whose value is to be ignored does some additional
work by setting the value(s) of some variable(s) to different values
then the FUNCTION call is not a waste of resources.  To ignore the
value returned by the TT(hello) FUNCTION, simply call the FUNCTION
without using the value like so: TT(hello(STRI("Ignored"));) For the
purposes of this question, try calling the TT(hello) FUNCTION without
using the return value by adding a line of code to the MAIN FUNCTION.
])

m6_answer([BO(Answer 1.6:)

m4_begin_indent
NI()BEGINMAIN EOL
PD hello(STRI("Ignored")); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 1.7: Comments.)  Study the following code.
Note the use of COMM(TT(dark green)) and SCOM(TT(red)) comments.
Comments are used to disable code for debugging purposes and also to
help explain how a program works.  The most useful comment in
J.T.W. and Java is SCOM(TT(/**)) until the first SCOM(TT(*/)).  This
type of comment is harvested by Javadoc to produce documentation on
how a CLASS works.  The second and third most useful comments are
(respectively) COMM(TT(//)) until the end of the line and COMM(TT(/*))
until the first COMM(TT(*/)).  The third type of comment is not very
useful because in J.T.W and Java you are not allowed to have one
comment inside another, so if you use this type of comment you will
constantly need to search for and remove COMM(TT(*/)) closing
comments.  In the tutorials that follow you will see many comments,
although mainly the first and second types of comments.

m4_begin_indent
NI()SCOM(/** This comment is harvested by Javadoc EOL
PD PD to document the MyFourthProgram class */) EOL
CLASS CLSS(MyFourthProgram) EOL
BEGIN COMM(// I am a single line comment) EOL
PD COMM(/* I am EOL
PD PD PD a multi-line EOL
PD PD PD PD PD comment */) EOL
PD SCOM(/** This comment is harvested by Javadoc EOL
PD PD PD to document the hello function */) EOL
PD FUNCTION STRING FUNC(hello)(STRING VARI(who)) EOL
PD BEGIN EOL
PD PD RETURN STRI("Hello ") + who + STRI("COMMA() how are you doing?"); EOL
PD END EOL
PD SCOM(/** This comment is harvested by Javadoc EOL
PD PD PD to document the main function */) EOL
PD BEGINMAIN EOL
PD PD SYSTEM_OUT_PRINTLN(hello(STRI("Anne"))); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#1])
