SECTION(9, Tutorial 9)

SUBSECTION(9.1, Elementary classes: using a single CLASS for everything)

m5_question([For the purpose of the text that follows, O.O.P. stands
for EM(<u>O</u>bject <u>O</u>riented <u>P</u>rogramming).])

m5_study(9.1)

m5_question(

m4_begin_indent
NU()m4_include(jtw-tutorials-old/files/Person-1.m4)
m4_end_indent

)

m5_question([BO(Question 9.2:) By copying the pattern established in
the existing code write a some new CLASS variables to represent a new
person called Barack Obama. Note that he was born in 1945 so at the
time of writing this manual he is 67 years old.])

m6_answer([BO(Answer 9.2:) Add the following code to the
CLSS(PersonDriver1) CLASS:

m4_begin_indent
NI()CLASSVAR STRING VARI(baracksName) = STRI("Barack Obama"); EOL
CLASSVAR INT    VARI(baracksAge)  = NUMB(67); EOL
m4_end_indent

])

m5_question([BO(Question 9.3:) Then write some functions to work
with this new person.])

m6_answer([BO(Answer 9.3:)

m4_begin_indent
NU()FUNCTION VOID FUNC(growBarack)() EOL
BEGIN EOL
PD baracksAge = baracksAge + NUMB(1); EOL
END EOL
 EOL
FUNCTION VOID FUNC(knightBarack)() EOL
BEGIN EOL
PD baracksName = STRI("Sir ") + baracksName; EOL
END EOL
 EOL
FUNCTION VOID FUNC(printBarack)() EOL
BEGIN EOL
PD SYSTEM_OUT_PRINTLN(STRI("I am ") + baracksName + STRI("COMMA() my age is ") + baracksAge); EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 9.4:) Finally call those functions from
the MAIN FUNCTION.])

m6_answer([BO(Answer 9.4:) Add the following code to the MAIN
FUNCTION:

m4_begin_indent
NU()growBarack(); EOL
knightBarack(); EOL
printBarack(); EOL
m4_end_indent

])

SUBSECTION(9.2, Improved classes: one object per CLASS)

m5_question([As your program gets large (say over 1000 lines) then it
becomes no longer practical to put all of your code in the same CLASS.
So it is natural to put each piece of related code in its own CLASS.
])

m5_study(9.5, [Each of these classes can be put in their own file.
For each CLASS CLSS(X), this CLASS can be put into a file called
TT(X.jtw).  However for the purposes of this tutorial you will
probably find it easier to merge all of the classes into the same file
into a file called TT(PersonDriver2.jtw)

m4_begin_indent
NU()m4_include(jtw-tutorials-old/files/Person-2.m4)
m4_end_indent

])

m5_question([BO(Question 9.6:) By copying the pattern established in
the existing code write a new CLASS to represent Barack Obama.])

m6_answer([BO(Answer 9.6:)

m4_begin_indent
NU()CLASS CLSS(Barack) EOL
BEGIN EOL
PD CLASSVAR STRING VARI(name) = STRI("Barack Obama"); EOL
PD CLASSVAR INT    VARI(age)  = NUMB(67); EOL
PD FUNCTION VOID FUNC(grow)() EOL
PD BEGIN EOL
PD PD age = age + NUMB(1); EOL
PD END EOL
PD FUNCTION VOID FUNC(knight)() EOL
PD BEGIN EOL
PD PD name = STRI("Sir ") + name; EOL
PD END EOL
PD FUNCTION VOID FUNC(print)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("I am ") + name + STRI("COMMA() my age is ") + age); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 9.7:) Call the functions from the MAIN
FUNCTION of the driver CLASS.])

m6_answer([BO(Answer 9.7:)

m4_begin_indent
NU()CLSS(Barack).grow(); EOL
CLSS(Barack).knight(); EOL
CLSS(Barack).print(); EOL
m4_end_indent

])

SUBSECTION(9.3, True O.O.P.: more than one object per CLASS)

m4_ifdef([m4_latex],\index{O.O.P.} \index{Object-Oriented
Programming}) m5_question([To allow for more than one object per
CLASS, most if not all CLASS variables needs to be made into what are
called EM(instance variables) (or more simply and more commonly known
as EM(properties)) and most if not all functions need to be made into
what are called EM(methods).

])

m5_study(9.8)

m5_question([

m4_begin_indent
NU()m4_include(jtw-tutorials-old/files/Person-3.m4)
m4_end_indent

In the above code, note the use of three references TT(h), TT(f) and

])

m5_question([BO(Question 9.9:) By copying the pattern established
in the existing code add some code to the MAIN FUNCTION add some code
to create a new person for Barack Obama.])

m6_answer([BO(Answer 9.9:) Add the following code to the MAIN
FUNCTION:

m4_begin_indent
NU()CLSS(Person) VARI(b) = NEW CLSS(Person)(); EOL
b.name = STRI("Barack Obama"); EOL
b.age  = NUMB(67); EOL
b.grow(); EOL
b.knight(); EOL
b.print(); EOL
m4_end_indent

])

SUBSECTION(9.4, [A common design pattern: private properties, public constructor and public getters])

m5_question([A common design pattern in Java and one that I present
for you in the following code is to make all of the properties of a
CLASS effectively read-only to all client classes by making all of the
properties EM(private) and providing EM(non-private) EM(getter)
methods for getting the values of the properties.  It is possible for
the original CLASS to change the values of the properties but other
classes (such as CLSS(PersonTest) below) are not capable of doing this,
without calling a METHOD of the original CLASS such the TT(grow) and
TT(knight) methods of the CLSS(Person) CLASS.  Finally an additional
thing known as a EM(constructor) is used to ensure that objects are
initialized with meaningful values for their properties.

])

m5_study(9.10)

m5_question([

m4_begin_indent
NU()m4_include(jtw-tutorials-old/files/Person-4.m4)
m4_end_indent

])

m5_question([BO(Question 9.11:) By copying the pattern established in
the existing code add some code to the MAIN FUNCTION add some code to
create a new person called Barack Obama.])

m6_answer([BO(Answer 9.11:)

m4_begin_indent
NU()CLSS(Person) VARI(b) = NEW CLSS(Person)(STRI("Barack Obama"), NUMB(63)); EOL
b.grow(); EOL
b.knight(); EOL
b.print(); EOL
m4_end_indent

])

SUBSECTION(9.5, Comparing strings)

m5_question([BO(Question 9.12:) Add a METHOD TT(unknight()) which
removes the TT(STRI("Sir ")) title if he has one.  One trap for young
players in J.T.W. or Java is to use the operator TT(==) to compare
strings like so:

m4_begin_indent
NU()FUNCTION BOOLEAN FUNC(myCompare)(STRING VARI(a), STRING VARI(b)) EOL
BEGIN EOL
PD RETURN a == b; COMM(// Works but not as expected!) EOL
END EOL
m4_end_indent

It compiles without error, but doesn't give you the result you were
expecting.  Instead you need to use the TT(equals) METHOD of the
STRING CLASS like so:

m4_begin_indent
NU()FUNCTION BOOLEAN FUNC(myCompare)(STRING VARI(a), STRING VARI(b)) EOL
BEGIN EOL
PD RETURN a.equals(b); EOL
END EOL
m4_end_indent

More generally, if TT(x) and TT(y) are a references to objects, then
TT(x == y) returns whether or not x and y are pointing to the same
object, whereas TT(x.equals(y)) returns whether or not the
EM(contents) of the objects referred to by TT(x) and TT(y) are
equal.  The meaning of the word EM(contents) varies from CLASS to
CLASS, but in the case of strings it means that the strings contain
the same data.

PP

You will also find the STRING CLASS' TT(substring) and
(TT(toUpperCase) or TT(toLowerCase)) methods useful here too.  See the
STRING CLASS of the TT(java.lang) package in the following link:

m4_begin_center
WEBSITE(http://docs.oracle.com/javase/1.5.0/docs/api)
m4_end_center

NU()for more details of these two methods.

])

m6_answer([BO(Answer 9.12:)

m4_begin_indent
NU()METHOD VOID FUNC(unknight)() EOL
BEGIN EOL
PD IF (name.substring(NUMB(0),NUMB(4)).equals(STRI("Sir "))) EOL
PD BEGIN EOL
PD PD name = name.substring(NUMB(4)); EOL
PD END EOL
END EOL
m4_end_indent

])

SUBSECTION(9.6, The NULL value for references)

m5_question([As soon as you learn how to use references you need to
know that all reference variables could conceivably hold the value
EM(null), meaning EM(no value).  In particular when properties are
themselves references as you will discover in TUTE_LINKS, then those
properties are initialized to NULL by default.  Object arrays that you
will learn about in TUTE_ARRAYS2 using the second of two
initialization syntaxes are also initialized to NULL by default.

SUBSECTION(9.7, Why the TT(toString) METHOD is better than any other
METHOD or property for debugging)

If TT(x) is a reference to a CLASS CLSS(X) (including TT(this)) and if
TT(m) is a METHOD of CLSS(X) and TT(p) is a property of CLSS(X), and
if TT(x) is currently NULL, then the following lines result in a
TT(NullPointerException) being thrown when executed:

m4_begin_indent
NU()x.p; EOL
x.m(); EOL
m4_end_indent

NU()whereas if TT(x) is NULL then

m4_begin_itemize
m4_item TT(SYSTEM_OUT_PRINTLN(x);) and
m4_item TT(SYSTEM_OUT_PRINTLN(STRI("x=") + x);)
m4_end_itemize

NU()prints out, respectively:

m4_begin_itemize
m4_item TT(NULL), and
m4_item TT(x=NULL).
m4_end_itemize

NU()If TT(x) is not NULL, it calls

m4_begin_itemize
m4_item TT(SYSTEM_OUT_PRINTLN(x.toString());)
m4_item TT(SYSTEM_OUT_PRINTLN(STRI("x=") + x.toString());)
m4_end_itemize

NU()so these expressions are safer to use than any other METHOD or
property in situations where TT(x) might be NULL.  The syntax of the
TT(toString) METHOD is as follows:

m4_begin_indent
NU()POBLIC METHOD STRING FUNC(toString)() EOL
BEGIN EOL
PD COMM(// Code goes here...) EOL
END EOL
m4_end_indent

Importantly for reasons which will be explained later the
TT(toString) METHOD must be declared with TT(public) visibility.
For other properties and methods to be used safely with NULL
references you need to wrap a conditional EM(if) construct around
the calling of the METHOD or property like so for properties:

m4_begin_indent
NU()IF (x != NULL) EOL
THEN BEGIN EOL
PD SYSTEM_OUT_PRINTLN(x.p); EOL
END EOL
m4_end_indent

NU()or like so for methods:

m4_begin_indent
NU()IF (x != NULL) EOL
THEN BEGIN EOL
PD SYSTEM_OUT_PRINTLN(x.m()); EOL
END EOL
m4_end_indent

NU()Therefore the TT(toString) METHOD is more convenient than any
other METHOD or property.  Note that its use is without the explicit
call to the TT(toString) METHOD and only used with a variable name,
including TT(this) for the current CLASS.  Most of the time the
TT(this) keyword is optional which is why novices don't bother to
learn it, but in the case of the TT(toString) METHOD it is essential,
as can be seen in the following example code:

m4_begin_indent
SYSTEM_OUT_PRINTLN(STRI("x.toString()=")    + x);
SYSTEM_OUT_PRINTLN(STRI("this.toString()=") + this);
m4_end_indent

])

m5_question([BO(Question 9.13:) Change the TT(print) METHOD above
from a METHOD that prints out to the screen to a METHOD called
TT(toString) that returns a string.])

m6_answer([BO(Answer 9.13:)

m4_begin_indent
NU()POBLIC METHOD STRING FUNC(toString)() EOL
BEGIN EOL
PD RETURN STRI("I am ") + name + STRI("COMMA() my age is ") + age; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 9.14:) Call the TT(toString) METHOD
instead of the TT(print) methods in the MAIN FUNCTION.])

m6_answer([BO(Answer 9.14:)

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("h=") + h); EOL
SYSTEM_OUT_PRINTLN(STRI("f=") + f); EOL
SYSTEM_OUT_PRINTLN(STRI("d=") + d); EOL
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#9])
