SECTION(10, Tutorial 10)

m5_question([This tutorial teaches you how to create single
dimensional and multi-dimensional arrays of objects.  The object types
are all types execpt for EM(boolean), EM(char), EM(int), EM(float) and
EM(double).  A helpful convention in Java is that the Object types
start with an uppercase letter, while non-object types start with a
lowercase letter, such as for example the STRING CLASS as an
example of an object type.  In addition to this, two different array
initialization syntaxes are presented.])

SUBSECTION(10.1, Single dimensional arrays)

m5_question([BO(Question 10.1:) Here is an example of a convenient one
dimensional array initialization syntax.  Study, compile and run the
following code.  The code CLSS(Person)TT([[[]]]) should be read out
loud as EM(person array) indicating the variable TT(a) is a EM(person
array), also known as an EM(array of persons).

m4_begin_indent
NU()CLASS CLSS(Person) EOL
BEGIN EOL
PD PRIVATE PROPERTY STRING VARI(name); EOL
EOL
PD POBLIC CONSTRUCTOR CLSS(Person)(STRING VARI(aName)) EOL
PD BEGIN EOL
PD PD name = aName; EOL
PD END EOL
EOL
PD POBLIC STRING FUNC(toString)() EOL
PD BEGIN EOL
PD PD RETURN name; EOL
PD END EOL
END EOL
EOL
CLASS CLSS(PersonTest) EOL
BEGIN EOL
PD BEGINMAIN EOL
PD PD VAR CLSS(Person)[] VARI(a) = SQU NEW CLSS(Person)(STRI("Person HASH 1")), NEW CLSS(Person)(STRI("Person HASH 2")), NEW CLSS(Person)(STRI("Person HASH 3")) GLY; EOL
EOL
PD PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,NUMB(3)); i=i+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("a[") + i + STRI("]=") + a[i]); EOL
PD PD END EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

NU()Due to a design oversight by the creators of Java you cannot use
this syntax to re-initialize an array like so:

m4_begin_indent
NU()COMM(// Compilation error) EOL
a = SQU NEW CLSS(Person)(STRI("Person HASH 4")), NEW CLSS(Person)(STRI("Person HASH 5")), NEW CLSS(Person)(STRI("Person HASH 6")), NEW CLSS(Person)(STRI("Person HASH 7")) GLY; EOL
m4_end_indent

NU()Luckily there is a way array around this oversight and that is to
use a design pattern where you introduce a temporary variable
like so:

m4_begin_indent
NU()COMM(// No error) EOL
VAR CLSS(Person)[] VARI(temp) = SQU NEW CLSS(Person)(STRI("Person HASH 4")), NEW CLSS(Person)(STRI("Person HASH 5")), NEW CLSS(Person)(STRI("Person HASH 6")), NEW CLSS(Person)(STRI("Person HASH 7")) GLY; EOL
a = temp; COMM(// Array "a" now holds Person HASH 4, Person HASH 5, Person HASH 6, Person HASH 7) EOL
m4_end_indent

NU()Later you will learn why this design pattern is useful for
re-initialising multi-dimensional arrays.

])

m5_question([BO(Question 10.2:) Write a FUNCTION in the CLASS
CLSS(PersonTest) called TT(print) that takes a CLSS(Person) array
argument and prints out the array.  You will need to use the
TT(length) property of the array parameter so your FUNCTION works with
arbitrary sized arrays.  Change the MAIN FUNCTION to what follows so
that it contains a call to the TT(print) FUNCTION.

m4_begin_indent
NU()VAR CLSS(Person)[] VARI(a) = SQU NEW CLSS(Person)(STRI("Person HASH 1")), NEW CLSS(Person)(STRI("Person HASH 2")), NEW CLSS(Person)(STRI("Person HASH 3"))GLY; EOL
print(a); EOL
m4_end_indent

])

m6_answer([BO(Answer 10.2:)

m4_begin_indent
NU()FUNCTION VOID FUNC(print)(CLSS(Person)[] VARI(a)) EOL
BEGIN EOL
PD FUR (VAR INT i=0; LT(i,a.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("a[") + i + STRI("]=") + a[i]); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 10.3:) Write your own CLASS called CLSS(Mine)
similar to the CLSS(Person) CLASS with a one int parameter
constructor, a private int property TT(p) and a TT(toString) METHOD
that converts TT(p) to a string.  Then write a FUNCTION in the
CLSS(PersonTest) CLASS with same name as the previous TT(print)
FUNCTION, except that this one takes a CLSS(Mine)TT([[[]]]), also
known as a CLSS(Mine) array.  You might recall from TUTE_ARRAYS1 that
this practice of having two functions with the same name is called
EM(FUNCTION name overloading).  Change the MAIN FUNCTION to what
follows so that it initializes an array of CLSS(Mine) point variables
and then calls the second TT(print) FUNCTION.

m4_begin_indent
NU()VAR CLSS(Mine)[] VARI(b) = SQU NEW CLSS(Mine)(NUMB(1)), NEW CLSS(Mine)(NUMB(2)), NEW CLSS(Mine)(NUMB(3)) GLY; EOL
print(b); EOL
m4_end_indent

])

m6_answer([BO(Answer 10.3:)

m4_begin_indent
NU()FUNCTION VOID FUNC(print)(CLSS(Mine)[] VARI(a)) EOL
BEGIN EOL
PD FUR (VAR INT i=0; LT(i,a.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("a[") + i + STRI("]=") + a[i]); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([Here is an example of a second initialization syntax.
For this particular example it is better to use the simpler, earlier
initialization syntax, but when the size of the array to be created is
to be determined at run-time, then the second syntax should used.  The
next question will show you an example of this.

m4_begin_indent
NU()BEGINMAIN EOL
PD VAR CLSS(Person)[] VARI(a) = NEW CLSS(Person)[NUMB(3)]; EOL
PD COMM(// at this point the array is all nulls) EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,NUMB(3)); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD a[i] = NEW CLSS(Person)(STRI("Person HASH ") + (i+NUMB(1))); EOL
PD END EOL
PD print(a); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 10.4:) Write a FUNCTION TT(create) takes one
INT argument, the size of the array to create and returns a
CLSS(Person) array of that size.  Make it so the TT(i)SUP(th) element
of the array is initialized to TT(STRI("Person HASH ") + i).  Call
this FUNCTION from the MAIN FUNCTION like so:

m4_begin_indent
NU()BEGINMAIN EOL
PD VAR CLSS(Person)[] VARI(a) = create(NUMB(3)); EOL
PD print(a); EOL
ENDMAIN EOL
m4_end_indent

])

m6_answer([BO(Answer 10.4:)

m4_begin_indent
NU()FUNCTION INT[] FUNC(create)(INT VARI(size)) EOL
BEGIN EOL
PD VAR CLSS(Person)[] VARI(result) = NEW CLSS(Person)[size]; EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,result.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD result[i] = NEW CLSS(Person)(STRI("Person HASH ") + (i+NUMB(1))); EOL
PD END EOL
PD RETURN result; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 10.5:) Write a FUNCTION TT(create2) takes one
int argument, the size of the array to create and returns a CLSS(Mine)
array of that size.  Make it so the TT(i)SUP(th) element of the
array's TT(toString) METHOD prints out TT(STRI("Mine HASH ") + i).
Why is it not possible to overload that TT(create) FUNCTION?  Try it
and see what the compiler says.  Call TT(create2) from the MAIN
FUNCTION like so:

m4_begin_indent
NU()BEGINMAIN EOL
PD VAR CLSS(Mine)[] VARI(a) = create2(NUMB(3)); EOL
PD print(a); EOL
ENDMAIN EOL
m4_end_indent

])

m6_answer([BO(Answer 10.5:) You cannot overload the TT(create)
METHOD because TT(create) and TT(create2) both have the same
arguments.  Note that you cannot overload based on the return type
of a FUNCTION because, as was discussed in TUTE_HELLO_WORLD you
might choose to ignore the return value of a FUNCTION, and in this
case it would be impossible to determine what FUNCTION you want to
call.

m4_begin_indent
NU()FUNCTION CLSS(Mine)[] FUNC(create2)(INT VARI(size)) EOL
BEGIN EOL
PD VAR CLSS(Mine)[] VARI(result) = NEW CLSS(Mine)[size]; EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,result.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD result[i] = NEW CLSS(Mine)(i+NUMB(1)); EOL
PD END EOL
PD RETURN result; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 10.6:) Write a FUNCTION TT(doubler) that
takes a CLSS(Person) array TT(x) and returns a new CLSS(Person) array
called TT(result) twice as big as TT(x).  Copy TT(x) into the
TT(result) before you return it.  The extra elements in TT(result)
should all be NULL.])

m6_answer([BO(Answer 10.6:)

m4_begin_indent
NU()FUNCTION CLSS(Person)[] FUNC(doubler)(CLSS(Person)[] VARI(x)) EOL
BEGIN EOL
PD VAR CLSS(Person)[] VARI(result) = NEW CLSS(Person)[x.length * NUMB(2)]; EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,x.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD result[i] = x[i]; EOL
PD END EOL
PD RETURN result; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 10.7:) Change the TT(doubler) FUNCTION so
that every NULL in the array TT(result) is set to a new CLSS(Person)
make it so that every new CLSS(Person) object has a different TT(name)
property.])

m6_answer([BO(Answer 7.7:)

m4_begin_indent
NU()FUNCTION CLSS(Person)[] FUNC(doubler)(CLSS(Person)[] VARI(x)) EOL
BEGIN EOL
PD VAR CLSS(Person)[] VARI(result) = NEW CLSS(Person)[x.length * NUMB(2)]; EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,x.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD result[i] = x[i]; EOL
PD END EOL
PD VAR INT VARI(count) = NUMB(1); EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,result.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD IF (result[i] == NULL) THEN EOL
PD PD BEGIN EOL
PD PD PD result[i] = NEW CLSS(Person)(STRI("Person HASH ") + count); EOL
PD PD PD count = count + NUMB(1); EOL
PD PD END EOL
PD END EOL
PD RETURN result; EOL
END EOL
m4_end_indent

])

SUBSECTION(10.2, Two dimensional arrays)

m5_question([BO(Question 10.8:) Here is an example of a convenient two
dimensional array initialization syntax.  Study, compile and run the
following code.  The code CLSS(Person)TT([[[][]]]) should be read out
loud as EM(person array array) indicating the variable TT(a) is a
EM(person array array), also known as a EM(two-dimensional array of
persons).

m4_begin_indent
NU()BEGINMAIN EOL
PD VAR CLSS(Person)[][] a = SQU SQU NEW CLSS(Person)(STRI("Person HASH 1")), NEW CLSS(Person)(STRI("Person HASH 2")), NEW CLSS(Person)(STRI("Person HASH 3")) GLY, EOL
PD PD PD PD PD PD PD SQU NEW CLSS(Person)(STRI("Person HASH 4")), NEW CLSS(Person)(STRI("Person HASH 5")) GLY, EOL
PD PD PD PD PD PD PD SQU NEW CLSS(Person)(STRI("Person HASH 6")) GLY GLY; EOL
EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,a.length); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,a[y].length); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINT(STRI(" ") + a[y][x]); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 10.9:) By copying the pattern of the code
above, do some more overloading of the TT(print) FUNCTION by writing
two new TT(print) functions, one taking a two dimensional array of
CLSS(Person), the other taken a two dimensional array of CLSS(Mine).  The
call both of these functions from the MAIN FUNCTION.])

m6_answer([BO(Answer 10.9:)

m4_begin_indent
NU()FUNCTION VOID FUNC(print)(CLSS(Person)[][] a) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,a.length); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,a[y].length); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINT(STRI(" ") + a[y][x]); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
FUNCTION VOID FUNC(print)(CLSS(Mine)[][] a) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,a.length); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,a[y].length); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINT(STRI(" ") + a[y][x]); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
m4_end_indent

NU()Here is what your MAIN FUNCTION should look like:

m4_begin_indent
NU()BEGINMAIN EOL
PD VAR CLSS(Person)[][] a = SQU SQU NEW CLSS(Person)(STRI("Person HASH 1")), NEW CLSS(Person)(STRI("Person HASH 2")), NEW CLSS(Person)(STRI("Person HASH 3")) GLY, EOL
PD PD PD PD PD PD PD PD SQU NEW CLSS(Person)(STRI("Person HASH 4")),NEW CLSS(Person)(STRI("Person HASH 5"))GLY EOL
PD PD PD PD PD PD PD PD SQU NEW CLSS(Person)(STRI("Person HASH 6")) GLY GLY; EOL
PD print(a); EOL
PD VAR CLSS(Mine)[][] b = SQU SQU NEW CLSS(Mine)(NUMB(1)), NEW CLSS(Mine)(NUMB(2)), NEW CLSS(Mine)(NUMB(3)) GLY, EOL
PD PD PD PD PD PD PD PD SQU NEW CLSS(Mine)(NUMB(4)), NEW CLSS(Mine)(NUMB(5)) GLY, EOL
PD PD PD PD PD PD PD PD SQU NEW CLSS(Mine)(NUMB(6)) GLY GLY; EOL
PD print(b); EOL
ENDMAIN EOL
m4_end_indent

])

m4_changequote(,)

m5_question([Since TT(a[0]) is a CLSS(Person) array, you would naively
expect it to be able to be re-initialized like so:

m4_begin_indent
NU()a[NUMB(0)] = SQU NEW CLSS(Person)(STRI("Person HASH 4")), EOL
PD PD PD NEW CLSS(Person)(STRI("Person HASH 5")), EOL
PD PD PD NEW CLSS(Person)(STRI("Person HASH 6")) GLY; EOL
m4_end_indent

NU()so that after this code TT(a[0]) holds the four element long array
TT(Person HASH 4),TT(Person HASH 5) and TT(Person HASH 6), but it
does't work owing to a design oversight by the creators of Java.
Luckily as mentioned above there is a way around this oversight and
that is to use a temporary variable like so:

m4_begin_indent
NU()VAR CLSS(Person)[] VARI(temp) = SQU NEW CLSS(Person)(STRI("Person HASH 4")), EOL
PD PD PD PD PD PD PD PD NEW CLSS(Person)(STRI("Person HASH 5")), EOL
PD PD PD PD PD PD PD PD NEW CLSS(Person)(STRI("Person HASH 6")) GLY; EOL
a[NUMB(0)] = temp; COMM(// Array "a[0]" now holds Person HASH 4, Person HASH 5, Person HASH 6) EOL
m4_end_indent

NU()Like with one dimensional arrays, there is a second initialisation
syntax for two dimensional arrays and here it is.  Unlike the above
code the sub-arrays TT(a[[[0]]]), TT(a[[[1]]]) and TT(a[[[2]]]) are
all of equal size, namely three.

m4_begin_indent
NU()VAR CLSS(Person)[][] VARI(a) = NEW CLSS(Person)[NUMB(3)][NUMB(3)]; EOL
a[NUMB(0)][NUMB(0)] = NEW CLSS(Person)(STRI("Person HASH 1")); EOL
a[NUMB(0)][NUMB(1)] = NEW CLSS(Person)(STRI("Person HASH 2")); EOL
a[NUMB(0)][NUMB(2)] = NEW CLSS(Person)(STRI("Person HASH 3")); EOL
a[NUMB(1)][NUMB(0)] = NEW CLSS(Person)(STRI("Person HASH 4")); EOL
a[NUMB(1)][NUMB(1)] = NEW CLSS(Person)(STRI("Person HASH 5")); EOL
a[NUMB(1)][NUMB(2)] = NEW CLSS(Person)(STRI("Person HASH 6")); EOL
a[NUMB(2)][NUMB(0)] = NEW CLSS(Person)(STRI("Person HASH 7")); EOL
a[NUMB(2)][NUMB(1)] = NEW CLSS(Person)(STRI("Person HASH 8")); EOL
a[NUMB(2)][NUMB(2)] = NEW CLSS(Person)(STRI("Person HASH 9")); EOL
m4_end_indent

])

m5_question([BO(Question 10.10:) Write a FUNCTION TT(create3) and
TT(create4) that takes an INT argument TT(size) and returns a two
dimensional array of CLSS(Person) or CLSS(Mine), respectively.  Make
is so that each CLSS(Person) or CLSS(Mine) object has its own number,
using a separate counter variable TT(INT VARI(count)).])

m6_answer([BO(Answer 10.10:)

m4_begin_indent
NU()FUNCTION CLSS(Person)[][] FUNC(create3)(INT VARI(size)) EOL
BEGIN EOL
PD VAR CLSS(Person)[][] VARI(a) = NEW CLSS(Person)[size][size]; EOL
PD VAR INT VARI(count) = NUMB(1); EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,size); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,size); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD a[y][x] = NEW CLSS(Person)(STRI("Person HASH ") + count); EOL
PD PD PD count = count + NUMB(1); EOL
PD PD END EOL
PD END EOL
PD RETURN a; EOL
END EOL
EOL
FUNCTION CLSS(Mine)[][] FUNC(create4)(INT VARI(size)) EOL
BEGIN EOL
PD VAR CLSS(Mine)[][] VARI(a) = NEW CLSS(Mine)[size][size]; EOL
PD VAR INT VARI(count) = NUMB(1); EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,size); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,size); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD a[y][x] = NEW CLSS(Mine)(count); EOL
PD PD PD count = count + NUMB(1); EOL
PD PD END EOL
PD END EOL
PD RETURN a; EOL
END EOL
m4_end_indent

])

SUBSECTION(10.3,  Three dimensional arrays)

m5_question([BO(Question 10.11:) Using the knowledge you have gained
so far about arrays, create, initialize and print a three dimensional
array of CLSS(Person).  Make it so that each CLSS(Person) object is
given its own number using a separate counter variable TT(INT
VARI(count)).])

m6_answer([BO(Answer 10.11:)

m4_begin_indent
NU()COMM(// create array) EOL
VAR CLSS(Person)[][][] VARI(a) = NEW CLSS(Person)[NUMB(3)][NUMB(3)][NUMB(3)]; EOL
VAR INT VARI(count) = NUMB(1); EOL
EOL
COMM(// initialize array) EOL
FUR (VAR INT VARI(z)=NUMB(0); LT(z,a.length); z=z+NUMB(1)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,a[z].length); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,a[z][y].length); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD a[z][y][x] = NEW CLSS(Person)(STRI("Person HASH ") + count); EOL
PD PD PD count = count + NUMB(1); EOL
PD PD END EOL
PD END EOL
END EOL
EOL
COMM(// print array) EOL
FUR (VAR INT VARI(z)=NUMB(0); LT(z,a.length); z=z+NUMB(1)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,a[z].length); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,a[z][y].length); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINT(STRI(" ") + a[z][y][x]); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
PD SYSTEM_OUT_PRINTLN(); EOL
END EOL
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#10])
