SECTION(12, Tutorial 12)

m5_question([BO(Question 12.1:) Write constructors for the classes
CLSS(SportsShoe) and CLSS(Runner) below, by looking at the MAIN FUNCTION
to see how many arguments each constructor has.

m4_begin_indent
NU()m4_include(jtw-tutorials-old/files/RunnerTest.m4)
m4_end_indent

])

m6_answer([BO(Answer 12.1:) The following CLSS(SportsShoe) constructor
belongs in the CLSS(SportsShoe) CLASS:

m4_begin_indent
NU()CONSTRUCTOR CLSS(SportsShoe)(STRING VARI(aModel), DOUBLE VARI(aSpeedBoost)) EOL
BEGIN EOL
PD model      = aModel; EOL
PD speedBoost = aSpeedBoost; EOL
END EOL
m4_end_indent

NU()The following CLSS(Runner) constructor belongs in the CLSS(Runner) CLASS:

m4_begin_indent
NU()CONSTRUCTOR CLSS(Runner)(STRING VARI(aName), INT VARI(aSpeed), CLSS(SportsShoe) VARI(aShoe)) EOL
BEGIN EOL
PD name  = aName; EOL
PD speed = aSpeed; EOL
PD shoes = aShoe; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 12.2:) In the CLSS(Runner) CLASS, write the
private METHOD TT(computeSpeed) that has no arguments and returns a
double-precision floating point value that equals the runner's running
speed.  Note that the speed of a runner is determined by multiplying
their TT(speed) property with the TT(speedBoost) property of the shoes
that they are wearing.  For example, Speedy Gonzalez's running speed =
55 * 2.0 = 110.0.])

m6_answer([BO(Answer 12.2:)

m4_begin_indent
NU()PRIVATE METHOD DOUBLE FUNC(computeSpeed)() EOL
BEGIN EOL
PD RETURN speed * shoes.speedBoost; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 12.3:) Fix the TT(race) METHOD so that it
checks for a draw.])

m6_answer([BO(Answer 12.3:)

m4_begin_indent
NU()FUNCTION VOID FUNC(race)(CLSS(Runner) VARI(r1), CLSS(Runner) VARI(r2)) EOL
BEGIN EOL
PD IF (GT(r1.computeSpeed(),r2.computeSpeed())) EOL
PD THEN BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r1.name + STRI(" beats ") + r2.name); EOL
PD END EOL
PD ELSE IF (GT(r1.computeSpeed(),r2.computeSpeed())) EOL
PD THEN BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r2.name + STRI(" beats ") + r1.name); EOL
PD END EOL
PD ELSE BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r1.name + STRI(" draws against ") + r2.name); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 12.4:) By copying the TT(race) METHOD,
write a three-parameter TT(race) METHOD for racing three runners
against each other.  Two methods in the same CLASS with the same name
is called EM(overloading) in Java.  Add a call to this METHOD from the
MAIN FUNCTION.])

m6_answer([BO(Answer 12.4:)

m4_begin_indent
NU()FUNCTION VOID FUNC(race)(CLSS(Runner) VARI(r1), CLSS(Runner) VARI(r2), CLSS(Runner) VARI(r3)) EOL
BEGIN EOL
PD IF (GT(r1.computeSpeed(),r2.computeSpeed()) AND GT(r1.computeSpeed(),r3.computeSpeed())) EOL
PD THEN BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r1.name + STRI(" wins")); EOL
PD END EOL
PD ELSE IF (GT(r2.computeSpeed(),r1.computeSpeed()) AND GT(r2.computeSpeed(),r3.computeSpeed())) EOL
PD THEN BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r2.name + STRI(" wins")); EOL
PD END EOL
PD ELSE IF (GT(r3.computeSpeed(),r1.computeSpeed()) AND GT(r3.computeSpeed(),r2.computeSpeed()))
PD THEN BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r3.name + STRI(" wins")); EOL
PD END EOL
PD ELSE BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("It's a draw!")); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 12.5:) What is the difference between a
METHOD and a FUNCTION?  Write a one parameter METHOD TT(raceAgainst)
that behaves exactly like two-parameter FUNCTION TT(race).  There are
two ways of doing this, one is to optionally use the THIS keyword
rather than one of the parameters TT(r1) or TT(r2).  The second way is
for TT(race) to simply call TT(race) using THIS as one of the
arguments to the FUNCTION.])

m6_answer([BO(Answer 12.5:) A METHOD has a current object associated
with it, accessed via the EM(this) keyword.  A METHOD can internally
call any other METHOD of the same CLASS.  A FUNCTION on the other hand
has no current object associated with it, and therefore cannot call
methods of the same CLASS.  They can however call other functions.
Here is the first way.  Note that the use of the THIS keyword is not
essential here:

m4_begin_indent
NU()METHOD VOID FUNC(raceAgainst)(CLSS(Runner) VARI(other)) EOL
BEGIN EOL
PD IF (GT(THIS.computeSpeed(),other.computeSpeed())) EOL
PD THEN BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + THIS.name + STRI(" beats ") + other.name); EOL
PD END EOL
PD ELSE BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + other.name + STRI(" beats ") + THIS.name); EOL
PD END EOL
END EOL
m4_end_indent

NU()Here is the second way.  Note that the THIS keyword is essential in
the code that follows:

m4_begin_indent
NU()METHOD VOID FUNC(raceAgainst)(CLSS(Runner) VARI(other)) EOL
BEGIN EOL
PD race(THIS,other); EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 12.6:) Is it true that any METHOD can be
re-worked into a FUNCTION and vice versa?])

m6_answer([BO(Answer 12.6:)

m4_begin_itemize

m4_item A METHOD with TT(n) parameters can always be re-worked into a
FUNCTION with TT(n+1) parameters.  The extra parameter is needed for
the current object, which is implicit in every METHOD.

m4_item A FUNCTION with TT(n) parameters with at least one argument of
the type that is the same as the enclosing CLASS can be reworked
into a METHOD with TT(n-1) parameters.  You lose one parameter
because that parameter is used to store the current object.

m4_end_itemize

NU()As you will discover later when EM(polymorphism) is introduced then
it is not possible to map functions to methods and vice-versa.
])

m5_question([BO(Question 12.7:) The TT(swapShoes) METHOD in the
CLSS(Runner) CLASS swaps the shoes of two runners.  Add some code to the
MAIN FUNCTION to swap the shoes of two runners and verify that the
shoes do indeed get swapped.])

m6_answer([BO(Answer 12.7:)

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("Before swapping shoes:")); EOL
sg.describe(); EOL
sw.describe(); EOL
CLSS(Runner).swapShoes(sg,sw); EOL
SYSTEM_OUT_PRINTLN(STRI("After swapping shoes:")); EOL
sg.describe(); EOL
sw.describe(); EOL
m4_end_indent

])

m5_question([BO(Question 12.8:) Write a METHOD called TT(swapNames)
that swaps the names of two runners.  You can put this FUNCTION into
any CLASS but it makes the most sense to put it into the CLSS(Runner)
CLASS since it has two CLSS(Runner) parameters.])

m6_answer([BO(Answer 12.8:)

m4_begin_indent
NU()FUNCTION VOID FUNC(swapNames)(CLSS(Runner) VARI(r1), CLSS(Runner) VARI(r2)) EOL
BEGIN EOL
PD VAR STRING VARI(tempName) = r1.name; EOL
PD r1.name = r2.name; EOL
PD r2.name = tempName; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 12.9:) Write a METHOD TT(swapSpeeds) that
swaps the TT(speed) properties of two runners.])

m6_answer([BO(Answer 12.9:)

m4_begin_indent
NU()FUNCTION VOID FUNC(swapSpeeds)(CLSS(Runner) VARI(r1), CLSS(Runner) VARI(r2)) EOL
BEGIN EOL
PD VAR INT VARI(tempSpeed) = r1.speed; EOL
PD r1.speed = r2.speed; EOL
PD r2.speed = tempSpeed; EOL
END EOL
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#12])

