
SECTION(14, Tutorial 14)

m5_question([Dr APOS(Seuss) story
AHREF(https://en.wikipedia.org/wiki/Yurtle_the_Turtle, EM(Yurtle the
Turtle)) describes how a turtle called Yurtle sits at the top of a pile
of other turtles. In this example, the pile of turtles is represented
by a linked list of CLSS(Turtle) objects, with the TT(down) property
serving to connect one CLSS(Turtle) object to another. If a
CLSS(Turtle) object has a non-NULL TT(down) property, then this
represents a turtle that is sitting below the current one. The last
turtle in the linked list is the turtle that is at the bottom of the
pile, which has a NULL value for its TT(down) property.])

m5_study(14.1)

m5_question([

m4_begin_indent
NU()m4_dnl
m4_include(jtw-tutorials-old/files/TurtleTest.m4)
m4_end_indent

The code in the MAIN FUNCTION after the TT(BO(***)) sets up the
following relationships between the three CLSS(Turtle) objects
(Bungle, Zippy and Yurtle).  The following diagram shows the
relationship between the different turtles.  When you traverse the
list of turtles you must always start at the top turtle (known as
the EM(head of the linked list)).  If you give a different value for
the top turtle, your code will think that the given turtle is the
one at the top of the pile and you will get the wrong result.

PCLOSE

m4_begin_center
<br>
m4_image(Turtles)
<br>
m4_end_center

POPEN

])

m5_question([BO(Question 14.2:) Move the code for calculating the
total weight of the turtles from the MAIN FUNCTION to a FUNCTION
called TT(FUNCTION VOID FUNC(printTotalWeight)(CLSS(Turtle)
VARI(top))) in the CLSS(Turtle) CLASS that prints out the total
weight of the turtles.  Then call that FUNCTION from the MAIN FUNCTION
to get the same result as before.  Note that that if
TT(printTotalWeight) was a METHOD then calling that METHOD using NULL
(representing an empty list) like so: TT(NULL.printTotalWeight())
would be an error, whereas TT(CLSS(Turtle).printTotalWeight(NULL))
APOS(wouldn)t be and therefore is better.  This is one example of how
methods and functions differ.])

m6_answer([BO(Answer 14.2:)

m4_begin_indent
NU()FUNCTION VOID FUNC(printTotalWeight)(CLSS(Turtle) VARI(top)) EOL
BEGIN EOL
PD VAR INT VARI(totalWeight) = NUMB(0); EOL
PD FUR (VAR CLSS(Turtle) VARI(current) = top; current != NULL; current=current.down) EOL
PD BEGIN EOL
PD PD totalWeight = totalWeight + current.weight; EOL
PD END EOL
PD SYSTEM_OUT_PRINTLN(STRI("The total weight is ") + totalWeight); EOL
END EOL
m4_end_indent

Then add the following code to the MAIN FUNCTION:
TT(CLSS(Turtle).printTotalWeight(yertle);).])

m5_question([BO(Question 14.3: Revision question for getters.) By
copying the pattern established by the TT(getName) METHOD, add two
getter methods to the CLSS(Turtle) CLASS: TT(getAge) which returns the
current APOS(turtle)s age and TT(getWeight) which returns the current
APOS(turtle)s weight.  Then call these methods on the Yurtle object in the
MAIN FUNCTION.  Note that the TT(toString) METHOD would be more
appropriate as it handles nulls better but you known that the
TT(yertle) reference is not NULL so you know it is safe to call the
TT(getAge) and TT(getWeight) methods on the TT(yertle) reference.])

m6_answer([BO(Answer 14.3:)

m4_begin_indent
NU()SCOM(/** getter METHOD for age property */) EOL
METHOD INT FUNC(getAge)() EOL
BEGIN EOL
PD RETURN age; EOL
END EOL
SCOM(/** getter METHOD for weight property */) EOL
METHOD DOUBLE FUNC(getWeight)() EOL
BEGIN EOL
PD RETURN weight; EOL
END EOL
m4_end_indent

Then add the following calls to the MAIN FUNCTION:

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("Yurtle's age is ") + yertle.getAge()); EOL
SYSTEM_OUT_PRINTLN(STRI("Yurtle's weight is ") + yertle.getWeight()); EOL
m4_end_indent

])

m5_question([BO(Question 14.4:) Write a FUNCTION
TT(CLSS(Turtle) FUNC(findBottomTurtle)(CLSS(Turtle) VARI(top))) that returns the
CLSS(Turtle) object that is at the top of the pile, and returns
NULL if there APOS(isn)t one.])

m6_answer([BO(Answer 14.4:)

m4_begin_indent
NU()FUNCTION CLSS(Turtle) FUNC(findBottomTurtle)(CLSS(Turtle) VARI(top)) EOL
BEGIN EOL
PD IF (top == NULL) THEN EOL
PD BEGIN EOL
PD PD RETURN NULL; EOL
PD END EOL
ELSE EOL
PD BEGIN EOL
PD PD VAR CLSS(Turtle) VARI(result) = top; EOL
PD PD WHILE (result.down != NULL) EOL
PD PD BEGIN EOL
PD PD PD result = result.down; EOL
PD PD END EOL
PD PD RETURN result; EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 14.5:) Then call this FUNCTION from the MAIN
FUNCTION using SYSTEM_OUT_PRINTLN and the top turtle TT(yertle).])

m6_answer([BO(Answer 14.5:)

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("top=") + CLSS(Turtle).findBottomTurtle(yertle)); EOL
m4_end_indent

])

m5_question([BO(Question 14.6:) Write a FUNCTION
TT(CLSS(Turtle) FUNC(findOldestTurtle)(CLSS(Turtle) VARI(top))) that returns the
oldest turtle or NULL if there APOS(isn)t one.])

m6_answer([BO(Answer 14.6:)

m4_begin_indent
NU()FUNCTION CLSS(Turtle) FUNC(findOldestTurtle)(CLSS(Turtle) VARI(top)) EOL
BEGIN EOL
PD IF (top == NULL) THEN EOL
PD BEGIN EOL
PD PD RETURN NULL; EOL
PD END EOL
ELSE EOL
PD BEGIN EOL
PD PD VAR CLSS(Turtle) VARI(oldestTurtle) = NULL; EOL
PD PD FUR (VAR CLSS(Turtle) VARI(temp) = top; temp != NULL; temp = temp.down) EOL
PD PD BEGIN EOL
PD PD PD IF (oldestTurtle == NULL) EOL
PD PD PD THEN BEGIN EOL
PD PD PD PD oldestTurtle = temp; EOL
PD PD PD END EOL
PD PD PD IF (GT(temp.age,oldestTurtle.age)) EOL
PD PD PD THEN BEGIN EOL
PD PD PD PD oldestTurtle = temp; EOL
PD PD PD END EOL
PD PD END EOL
PD PD RETURN oldestTurtle; EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 14.7:) Then call this FUNCTION from the MAIN
FUNCTION using SYSTEM_OUT_PRINTLN and the top turtle TT(yertle).])

m6_answer([BO(Answer 14.7:)

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("oldest=") + findOldestTurtle(yertle)); EOL
m4_end_indent
])

m5_question([BO(Question 14.8:) Write a FUNCTION
TT(CLSS(Turtle) FUNC(findHeaviestTurtle)(CLSS(Turtle) VARI(top))) returns the
heaviest turtle, or NULL if there APOS(isn)t one.])

m6_answer([BO(Answer 14.8:)

m4_begin_indent
NU()FUNCTION CLSS(Turtle) FUNC(findHeaviestTurtle)(CLSS(Turtle) VARI(top)) EOL
BEGIN EOL
PD IF (top == NULL) THEN EOL
PD BEGIN EOL
PD PD RETURN NULL; EOL
PD END EOL
ELSE EOL
PD BEGIN EOL
PD PD VAR CLSS(Turtle) VARI(heaviestTurtle) = NULL; EOL
PD PD FUR (VAR CLSS(Turtle) VARI(temp) = top; temp != NULL; temp = temp.down) EOL
PD PD BEGIN EOL
PD PD PD IF (heaviestTurtle == NULL) EOL
PD PD PD THEN BEGIN EOL
PD PD PD PD heaviestTurtle = temp; EOL
PD PD PD END EOL
PD PD PD IF (GT(temp.age,heaviestTurtle.age)) EOL
PD PD PD THEN BEGIN EOL
PD PD PD PD heaviestTurtle = temp; EOL
PD PD PD END EOL
PD PD END EOL
PD PD RETURN heaviestTurtle; EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 14.9:) Then call this FUNCTION from the
MAIN FUNCTION using SYSTEM_OUT_PRINTLN and the top turtle
TT(yertle).])

m6_answer([BO(Answer 14.9:)

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("heaviest=") + Turtle.findHeaviestTurtle(yertle)); EOL
m4_end_indent

])

m5_question([BO(Question 14.10:) Write a FUNCTION
TT(VOID FUNC(sayPile)(CLSS(Turtle) VARI(top))) that prints the names of the
turtles in the pile starting from the top turtle and finishing at
the bottom turtle.  Then call this FUNCTION from the MAIN FUNCTION.])

m6_answer([BO(Answer 14.10:)

m4_begin_indent
NU()FUNCTION VOID FUNC(sayPile)(CLSS(Turtle) VARI(top)) EOL
BEGIN EOL
PD SYSTEM_OUT_PRINT(STRI("The pile is (from top to bottom): ")); EOL
PD FUR (VAR CLSS(Turtle) VARI(temp)=top; temp != NULL; temp = temp.down) EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINT(STRI(" ") + temp.name); EOL
PD END EOL
PD SYSTEM_OUT_PRINTLN(); EOL
END EOL
m4_end_indent

Then add the following code to the MAIN FUNCTION:
TT(CLSS(Turtle).sayPile(yertle);).])

m5_question([BO(Question 14.11:) Under what circumstances would it
be okay to change the visibility of the TT(down) property to private,
like the TT(name), TT(age) and TT(weight) properties?])

m6_answer([BO(Answer 14.11:) If you must change the visibility
status of the TT(down) property to private then you should add some
methods for altering the linked list (and therefore adjusting the
TT(down) property) like so:

m4_begin_indent
NU()METHOD VOID FUNC(insert)(CLSS(Turtle) VARI(t)) EOL
BEGIN EOL
PD VAR CLSS(Turtle) VARI(temp) = THIS.down; EOL
PD THIS.down = t; EOL
PD t.down = temp; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 14.11:) Add an extra parameter to the
constructor which is a reference the to the turtle below of the
current one.  Then remove all occurrences of the TT(down) property
from the MAIN FUNCTION.  The advantage of this is that it enables you
to change the visibility of the TT(down) property to PRIVATE.])

m6_answer([BO(Answer 14.11:) Change the CLSS(Turtle) constructor to
be like so:

m4_begin_indent
NU()m4_dnl
CONSTRUCTOR CLSS(Turtle)(STRING VARI(aName), INT VARI(anAge), DOUBLE VARI(aWeight), CLSS(Turtle) VARI(aDown)) EOL
BEGIN EOL
PD name = aName; EOL
PD age = anAge; EOL
PD weight = aWeight; EOL
PD down = aDown; EOL
END EOL
m4_end_indent

Then change the calls to the constructor in the MAIN FUNCTION to be like so:

m4_begin_indent
NU()m4_dnl
VAR CLSS(Turtle) VARI(bungle) = NEW CLSS(Turtle)(STRI("Bungle"), NUMB(100), NUMB(40),NULL); EOL
VAR CLSS(Turtle) VARI(zippy)  = NEW CLSS(Turtle)(STRI("Zippy"),  NUMB(100), NUMB(30),bungle); EOL
VAR CLSS(Turtle) VARI(yertle) = NEW CLSS(Turtle)(STRI("Yurtle"), NUMB(100), NUMB(20),zippy); EOL
m4_end_indent

Then remove all occurrences of the TT(down) property in the MAIN
FUNCTION.  When you have done this, you should be change the
visibility of the TT(down) property to private and everything should
compile and run like it used to.])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#14])

