SECTION(15, Tutorial 15)

SUBSECTION(15.1,Basic Inheritance)

m5_question([When you see the following code: TT(CLASS CLSS(X) EXTENDS
CLSS(Y)), it means that CLASS CLSS(X) EM(inherits) from the CLASS
CLSS(Y).  Class CLSS(X) is called the EM(subclass) and the CLASS
CLSS(Y) is called the EM(super-class) or sometimes the EM(parent)
CLASS.  When the CLASS CLSS(X) extends from CLSS(Y), it pulls in all
of the non-PRIVATE methods and properties from the super-class CLSS(Y).
Inherited methods can override the behaviour of that same METHOD in the
super-class to give behaviour that is specific to the subclass.  The
concept of methods overriding other methods is called EM(dynamic
METHOD binding) or more commonly the more impressive-sounding name:
EM(polymorphism).  The main thing that this tutorial shows is the idea
that inheritance is a non-symmetrical relationship. For example: in
the code that follows, the CLSS(Bird) CLASS inherits from the
CLSS(Animal) CLASS, which corresponds to the idea that EM(every bird
is an animal). The reverse, EM(every animal is a bird) is plainly not
true! Inheritance forces you to recognize this.])

m5_question([BO(Question 15.1:) Study, compile and run the
following code.  The following code shows how inheritance works.  In
the following code, the CLSS(Bird) CLASS inherits from the CLSS(Animal)
CLASS.  The CLSS(Bird) CLASS pulls in the CLSS(Animal) CLASS's TT(age)
property and the TT(canFly) and TT(talk) methods.  Importantly the
TT(canFly) property overrides the behaviour of the TT(canFly) METHOD of
the parent CLSS(Animal) CLASS, which reflects that fact that generally
speaking, birds can fly.  In the code that follows, note that EM(int)
properties are initialized to zero by default and the EM(super) METHOD
(also known as the constructor of the super-class) is called by default
if there is a zero parameter constructor in the super-class, which
there is by default, even if you don't write one!

m4_begin_indent
NI()CLASS CLSS(Animal) EOL
BEGIN EOL
EOL
PD PROPERTY INT VARI(age); COMM(// Animal's age in years) EOL
PD PROPERTY INT VARI(health); COMM(// Animal's health in hit points) EOL
EOL
PD CONSTRUCTOR CLSS(Animal)() EOL
PD BEGIN EOL
PD PD age    = NUMB(0); COMM(// NOTE: not needed as set by default) EOL
PD PD health = NUMB(100); EOL
PD END EOL
EOL
PD METHOD BOOLEAN FUNC(canFly)() EOL
PD BEGIN EOL
PD PD RETURN FALSE; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Hello")); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Bird) EXTENDS CLSS(Animal) EOL
BEGIN EOL
EOL
PD PROPERTY DOUBLE VARI(flySpeed); COMM(// Bird's speed in km/h) EOL
EOL
PD CONSTRUCTOR CLSS(Bird)() EOL
PD BEGIN EOL
PD PD SUPER();PD PADD()PD COMM(// NOTE: not needed as called by default) EOL
PD PD flySpeed = NUMB(0); COMM(// NOTE: not needed as set by default) EOL
PD END EOL
EOL
PD METHOD BOOLEAN FUNC(canFly)() EOL
PD BEGIN EOL
PD PD RETURN TRUE; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(peck)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("peck")); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(InheriTest) EOL
BEGIN EOL
PD BEGINMAIN EOL
PD PD VAR CLSS(Bird) VARI(eagle) = NEW CLSS(Bird)(); EOL
PD PD eagle.talk(); EOL
PD PD eagle.peck(); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 15.2:) Override the TT(talk) METHOD of the
CLSS(Animal) CLASS in the CLSS(Bird) CLASS to print out STRI(TT("Tweet
Tweet!"))  rather than STRI(TT("hello")) to give more accurate talking
of bird objects.])

m6_answer([BO(Answer 15.2:)

m4_begin_indent
NI()METHOD VOID FUNC(talk)() EOL
BEGIN EOL
PD SYSTEM_OUT_PRINTLN(STRI("Tweet Tweet!")); EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 15.3:) By copying the pattern established in
the CLSS(Bird) CLASS, change the eagle from an instance of the
CLSS(Bird) CLASS to its own CLASS in its own right and then create an
instance of that CLASS in the MAIN FUNCTION of CLSS(InheriTest).  Your
CLSS(Eagle) CLASS should have one PROPERTY: TT(int numberOfKills) and
one METHOD: TT(void attack()) that internally increments the value of
TT(numberOfKills).  In the MAIN FUNCTION you should call every METHOD
of the CLSS(Eagle) CLASS and its super-classes.])

m6_answer([BO(Answer 15.3:)

m4_begin_indent
NI()CLASS CLSS(Eagle) EXTENDS CLSS(Bird) EOL
BEGIN EOL
EOL
PD PROPERTY INT VARI(numberOfKills); EOL
EOL
PD CONSTRUCTOR CLSS(Eagle)() EOL
PD BEGIN EOL
PD PD SUPER();PD PD   PADD()PD COMM(// NOTE: not needed as called by default) EOL
PD PD numberOfKills = NUMB(0); COMM(// NOTE: not needed as set by default) EOL
PD END EOL
EOL
PD METHOD VOID FUNC(attack)() EOL
PD BEGIN EOL
PD PD numberOfKills = numberOfKills + NUMB(1); EOL
PD END EOL
END EOL
m4_end_indent

Here is what the MAIN FUNCTION should look like:

m4_begin_indent
NI()BEGINMAIN EOL
PD VAR CLSS(Eagle) VARI(myEagle) = NEW CLSS(Eagle)(); EOL
PD myEagle.talk(); EOL
PD SYSTEM_OUT_PRINTLN(myEagle.canFly()); EOL
PD myEagle.peck(); EOL
PD myEagle.attack(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 15.4:) What is the advantage of using a
new separate CLASS to represent a new object rather than using an
instance of an existing CLASS?])

m6_answer([BO(Answer 15.4:) The answer is that using a separate
CLASS allows you to and new methods and to override existing methods,
which is not possible when you use an instance of an existing CLASS.])

m5_question([BO(Question 15.5:) Create a new CLASS CLSS(Kiwi) that
inherits from the CLSS(Bird) CLASS.  Your CLSS(Kiwi) CLASS should override
the TT(canFly) METHOD to return false, which reflects the fact that
generally speaking birds can fly, but the kiwi bird in particular does
not fly.  Your CLSS(Kiwi) CLASS have a property TT(numberOfWorms).  Once
you have written the CLSS(Kiwi) CLASS you should create an instance of
the CLSS(Kiwi) CLASS in the MAIN FUNCTION.])

m6_answer([BO(Answer 15.5:)

m4_begin_indent
NI()CLASS CLSS(Kiwi) EXTENDS CLSS(Bird) EOL
BEGIN EOL
EOL
PD PROPERTY INT VARI(numberOfWorms); EOL
EOL
PD CONSTRUCTOR CLSS(Kiwi)() EOL
PD  BEGIN EOL
PD PD SUPER();PD PD   PADD()PD COMM(// NOTE: not needed as called by default) EOL
PD PD numberOfWorms = NUMB(0); COMM(// NOTE: not needed as set by default) EOL
PD END EOL
EOL
PD METHOD BOOLEAN FUNC(canFly)() EOL
PD BEGIN EOL
PD PD RETURN FALSE; EOL
PD END EOL
END EOL
m4_end_indent

NI()and your MAIN FUNCTION should look like this:

m4_begin_indent
NI()BEGINMAIN EOL
PD VAR CLSS(Kiwi) VARI(k) = NEW CLSS(Kiwi)(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 15.6:) Why does the following line of code
in the MAIN FUNCTION print out 100 but there is no setting of that
variable to that value in the Kiwi CLASS?

m4_begin_indent
NI()SYSTEM_OUT_PRINTLN(k.health); EOL
m4_end_indent

])

m6_answer([BO(Answer 15.6:) Because that value is set in the
super-class's super-class CLASS CLSS(Animal).])

m5_question([BO(Question 15.7:) In the classes CLSS(Animal),
CLSS(Bird), CLSS(Eagle) and CLSS(Kiwi), remove all of the TT(canFly) methods
and replace it with a single TT(canFly) property of the CLSS(Animal)
CLASS.  In the constructors you will need to set the value of the
TT(canFly) PROPERTY to a value that is appropriate for that CLASS.
For example in the CLSS(Bird) CLASS's CONSTRUCTOR you should set the
TT(canFly) property to true, while in the CLSS(Kiwi) CLASS's CONSTRUCTOR
you should set the TT(canFly) PROPERTY to false.])

m6_answer([BO(Answer 15.7:)

m4_begin_indent
NI()CLASS CLSS(Animal) EOL
BEGIN EOL
EOL
PD PROPERTY INT VARI(age); COMM(// Animal's age in years) EOL
PD PROPERTY INT VARI(health); COMM(// Animal's health in hit points) EOL
PD PROPERTY BOOLEAN VARI(canFly); EOL
EOL
PD CONSTRUCTOR CLSS(Animal)() EOL
PD BEGIN EOL
PD PD age = NUMB(0);PD PD COMM(// NOTE: not needed as set by default) EOL
PD PD health = NUMB(100); EOL
PD PD canFly = FALSE; PADD() COMM(// NOTE: not needed as set by default) EOL
PD END EOL
EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Hello")); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Bird) EXTENDS CLSS(Animal) EOL
BEGIN EOL
EOL
PD PROPERTY DOUBLE VARI(flySpeed); COMM(// Bird's speed in km/h) EOL
EOL
PD CONSTRUCTOR CLSS(Bird)() EOL
PD BEGIN EOL
PD PD SUPER(); PADD()PD   COMM(// NOTE: not needed as called by default) EOL
PD PD flySpeed = NUMB(0); COMM(// NOTE: not needed as set by default) EOL
PD PD canFly = TRUE; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Tweet Tweet!")); EOL
PD END EOL
EOL
PD METHOD VOID FUNC(peck)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("peck")); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Eagle) EXTENDS CLSS(Bird) EOL
BEGIN EOL
EOL
PD PROPERTY INT VARI(numberOfKills); EOL
EOL
PD CONSTRUCTOR CLSS(Eagle)() EOL
PD  BEGIN EOL
PD PD SUPER();  PADD()PD PD PD COMM(// NOTE: not needed as called by default) EOL
PD PD numberOfKills = NUMB(0); COMM(// NOTE: not needed as set by default) EOL
PD END EOL
EOL
PD METHOD VOID FUNC(attack)() EOL
PD BEGIN EOL
PD PD numberOfKills = numberOfKills + NUMB(1); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Kiwi) EXTENDS CLSS(Bird) EOL
BEGIN EOL
EOL
PD PROPERTY INT VARI(numberOfWorms); EOL
EOL
PD CONSTRUCTOR CLSS(Kiwi)() EOL
PD  BEGIN EOL
PD PD SUPER();PD PD   PADD()PD COMM(// NOTE: not needed as called by default) EOL
PD PD numberOfWorms = NUMB(0); COMM(// NOTE: not needed as set by default) EOL
PD PD canFly = FALSE; EOL
PD END EOL
END EOL
m4_end_indent

In the MAIN FUNCTION you will need to change the METHOD call
TT(myEagle.canFly()) to a property access TT(myEagle.canFly).])

m5_question([BO(Question 15.8:) What is the advantage of having a
TT(canFly) PROPERTY over a bunch of TT(canFly) METHODS?])

m6_answer([BO(Answer 15.8:) Having a TT(canFly) property allows
you to change the value of this property at run-time, reflecting the
fact that a particular animal which can fly such as an eagle might
at some point lose its ability to fly due to something like wing
damage.])

m5_question([There is an equally valid alternative to having a POBLIC
PROPERTY in the CLSS(Animal) CLASS and that is to have in the
CLSS(Animal) CLASS a PRIVATE PROPERTY TT(canFly) and a pair of methods
for getting and setting the value of the TT(canFly) property like so.
These methods in J.T.W. and Java are called EM(getter) methods and
EM(setter) methods since, as their names suggest, getters are used for
getting the value of something and setters are used for setting the
value of something.  Note that the TT(canFly) METHOD of the code above
corresponds to TT(getCanFly) METHOD in the code below.

m4_begin_indent
NI()PRIVATE PROPERTY BOOLEAN VARI(canFly); EOL
EOL
METHOD BOOLEAN FUNC(getCanFly)() EOL
BEGIN EOL
PD RETURN canFly; EOL
END EOL
EOL
METHOD VOID FUNC(setCanFly)(BOOLEAN VARI(aCanFly)) EOL
BEGIN EOL
PD canFly = aCanFly; EOL
END EOL
m4_end_indent

NI()You might think that it is simpler to have one thing (a single
non-PRIVATE PROPERTY) rather than three things (a PRIVATE property and
a non-PRIVATE getter METHOD and a non-PRIVATE setter METHOD) and you
would be right.  However from the point of view of the client code
that uses the CLSS(Animal) CLASS, the two approaches are identical.
Later on when you learn more you will understand under what
circumstances the second getter and setter approach is better.

])


m4_define(QEST_A_B,15.9)

m5_question([BO(Question 15.9:) Change the MAIN FUNCTION to what
follows:

m4_begin_indent
NI()VAR CLSS(Bird) VARI(b) = NEW CLSS(Bird)(NUMB(10)); EOL
VAR CLSS(Animal) VARI(a) = b; EOL
a.talk(); EOL
a.peck(); EOL
m4_end_indent

NI()When you compile this code it gives a compilation error.  What
line gives the error and what is the reason for the error?])

m6_answer([BO(Answer 15.9:) The fourth line TT(a.peck();) is an
error because you cannot call a CLSS(Bird) CLASS's METHOD using a
reference to an CLSS(Animal) object.])

m5_question([BO(Question 15.10:) Change the MAIN FUNCTION to what
follows:

m4_begin_indent
NI()VAR CLSS(Animal) VARI(a) = NEW CLSS(Animal)();EOL
VAR CLSS(Bird) VARI(b) = a;EOL
b.talk();EOL
b.peck();EOL
m4_end_indent

NI()When you compile this code it gives a compilation error.  What line
gives the error and what is the reason for the error?

])

m6_answer([BO(Answer 15.10:) The second line TT(VAR CLSS(Bird) VARI(b)
= a;) is an error because you cannot convert a reference to an animal
to a reference to a bird, because not every animal is a bird.  The
line TT(a = b) in the Question QEST_A_B of the previous code was okay
because every bird is an animal, so therefore a reference to bird can
be converted into a reference to an animal.])

SUBSECTION(15.2,Run-time type inquiry)

m5_question([In J.T.W. and Java there is a keyword called EM(instanceof)
that does a run-time check on the type of an object.  The following
FUNCTION:

m4_begin_indent
NI()FUNCTION VOID FUNC(say)(CLSS(Animal) VARI(a)) EOL
BEGIN EOL
PD SYSTEM_OUT_PRINTLN(a INSTANCEOF CLSS(Bird)); EOL
END EOL
m4_end_indent

NI()uses the INSTANCEOF keyword to determine the run-time type of the
reference TT(a) and prints out whether or not the reference is
referring to a CLSS(Bird) object.  Some examples should clarify the
situation:

m4_begin_itemize
m4_item TT(say(NEW CLSS(Bird)()))   prints TRUE, Since the parameter TT(a) is pointing to a bird object at run-time,
m4_item TT(say(NEW CLSS(Animal)())) prints FALSE since not every animal is a bird,
m4_item TT(say(NEW CLSS(Eagle)()))  prints TRUE, since every eagle is a bird, and
m4_item TT(say(NEW CLSS(Kiwi)()))   prints TRUE, since every kiwi is a bird.
m4_item TT(VAR CLSS(Animal) VARI(a) = NEW CLSS(Animal)(); say(a);) prints FALSE since at run-time TT(a) is not pointing to a bird object
m4_item TT(VAR CLSS(Animal) VARI(a) = NEW CLSS(Bird)(); say(a);) prints TRUE since at run-time TT(a) is pointing to a bird object.

m4_end_itemize

In TUTE_BADIF you will learn why in most cases it is better to use
polymorphism instead of the INSTANCEOF keyword for run-time type
enquiry.

SUBSECTION(15.3, The super-class of all objects)

Every CLASS in Java inherits either directly or indirectly from a
CLASS called EM(Object).  That is to say if TT(x) is a reference
variable, then the run-time expression TT(x instanceof CLSS(Object))
is always true except for the pathological case where TT(x) is NULL
(i.e. is currently pointing to EM(no object)).  The TT(Object) CLASS
contains a METHOD called TT(toString) that returns a string containing
the run-time CLASS name of the object concatenated with the something
like the memory address of the object in base 16 (also known as
EM(hexadecimal)) format.  Since every CLASS inherits from
CLSS(Object), every object can have TT(toString) invoked upon it.
Even better, every CLASS CLSS(X) can override TT(toString) to provide
debugging information that is tailored to CLSS(X).  Therefore the
TT(toString) METHOD is convenient for debugging.  Since the
TT(toString) METHOD is a POBLIC METHOD of the CLSS(Object) CLASS it
must be overridden as a POBLIC METHOD, since your overridden FUNCTION
cannot have weaker access privileges.])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#15])

