SECTION(18, Advanced J.T.W.)

SUBSECTION(18.1, Mapping J.T.W. to Java)

Here is how to map from J.T.W. to Java:

m4_changequote(,)

<blockquote>
  <table>
    <tr>
      <td>FUNCTION</td><td>ARROW TT(BO(static))</td>
    </tr>
    <tr>
      <td>VAR</td><td>ARROW EM(nothing)</td>
    </tr>
    <tr>
      <td>CLASSVAR</td><td>ARROW TT(BO(static))</td>
    </tr>
    <tr>
      <td>PROPERTY</td><td>ARROW EM(nothing)</td>
    </tr>
    <tr>
      <td>METHOD</td><td>ARROW EM(nothing)</td>
    </tr>
    <tr>
      <td>CONSTRUCTOR</td><td>ARROW EM(nothing)</td>
    </tr>
    <tr>
      <td>BEGIN</td><td>ARROW TT(SQU)</td>
    </tr>
    <tr>
      <td>END</td><td>ARROW TT(GLY)</td>
    </tr>
    <tr>
      <td>BEGINMAIN</td><td>ARROW TT(POBLIC STATIC VOID FUNC(main)(STRING[] VARI(args)) SQU)</td>
    </tr>
    <tr>
      <td>ENDMAIN</td><td>ARROW TT(GLY)</td>
    </tr>
    <tr>
      <td>AND</td><td>ARROW TT(BO(AMP()AMP()))</td>
    </tr>
    <tr>
      <td>OR</td><td>ARROW TT(BO(BAR()BAR()))</td>
    </tr>
    <tr>
      <td>THEN</td><td>ARROW EM(nothing)</td>
    </tr>
    <tr>
      <td>ELSEIF</td><td>ARROW ELSE IF</td>
    </tr>
  </table>
</blockquote>

<br>
NI()Here is an J.T.W. program:
<br>
<br>

m4_begin_indent
NI()CLASS CLSS(HelloWorld) EOL
BEGIN EOL
PD BEGINMAIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("COMMA(Hello) World!")) EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

<br>
NI()Here is the same J.T.W. program, after conversion to the Java language:
<br>
<br>

m4_begin_indent
NI()CLASS CLSS(HelloWorld) EOL
SQU EOL
PD POBLIC STATIC VOID FUNC(main)(STRING[] VARI(args)) EOL
PD SQU EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("COMMA(Hello) World!")) EOL
PD GLY EOL
GLY EOL
m4_end_indent

<br>
NI()Note that these J.T.W. keywords on the left hand side of the above
diagram should not map to their Java equivalents inside strings and
comments.  The transformation was originally written to use the m4
language to map J.T.W. onto Java but this approach had the disadvantage
that keywords like BEGIN and END inside strings were mapped to their
Java equivalents like so:
<br>
<br>

<blockquote>
  <table>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("function"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("static"));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("var"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI(""));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("classVar"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("static"));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("property"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI(""));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("method"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI(""));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("constructor"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI(""));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("begin"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("SQU"));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("end"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("GLY"));</td>
    </tr>
    m4_changequote(,)
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("beginMain"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("public static void main(String[] args) {"));</td>
    </tr>
    m4_changequote([,])
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("endMain"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("}"));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("and"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("AMP()AMP()"));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("or"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("BAR()BAR()"));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("then"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI(""));</td>
    </tr>
    <tr>
      <td>SYSTEM_OUT_PRINTLN(STRI("elseif"));</td><td>ARROW SYSTEM_OUT_PRINTLN(STRI("else if"));</td>
    </tr>
  </table>
</blockquote>

<br>
NI()which is of course the wrong behaviour.  A hack to get around this
limitation is to break apart the J.T.W. keywords like so:
<br>
<br>

m4_begin_indent
NI()SYSTEM_OUT_PRINTLN(STRI("be") + STRI("gin")); EOL
m4_end_indent

m4_ifdef([m4_latex],[
\index{Flex!Compiling J.T.W. to Java}
\index{Compiling J.T.W. to Java!Flex}
\index{Emacs!Compiling J.T.W. to Java}
\index{Compiling J.T.W. to Java!Emacs}])

</p>
<p align="justify">

  NI()This problem can be fixed for good either by using Flex to compile J.T.W.
  into Java or to use Emacs to do the same thing, only a little slower
  than what Flex can do.  In the end I chose GNU Emacs as the host for
  the preprocessor language J.T.W. because it is free software and is
  adequate for my programming needs and is more powerful than Flex or
  m4.

</p>
<p align="justify">

  To remedy this deficiency Emacs' EM(batch mode) is used to do the
  transformation from J.T.W. to Java.  This implies that GNU Emacs must be
  present on the client's system to do the J.T.W. to Java mapping.  Of
  course, there is no compulsion to use Emacs as an editor, although
  there are a couple of advantages in doing this.  Number one is that
  J.T.W. keywords, comments and strings have CLSS(syntax)
  FUNC(highlighting).  And number two is that Emacs can do correct
  automatic indentation of J.T.W. code.

  SUBSECTION(18.2, TT(Makefile) for building TT(*.jtw) into TT(*.java)
  and running TT(*.class) files)

  Here is the EM(GNU Makefile):

  m4_begin_indent
FUNC(.PRECIOUS:) EOL
FUNC(.PRECIOUS:) FUNC(%.java) FUNC(%.CLASS) EOL
EOL
VARI(JAVAC_FLAGS) = -source 1.5 -Xlint:unchecked -Xlint:deprecation EOL
VARI(JAVA_FLAGS)  = -enableassertions EOL
VARI(SHELL)       = /bin/bash EOL
EOL
FUNC(%.java:) FUNC(%.jtw) EOL
PD PD @echo STRI("* Stage 1 : Debugging $*.jtw file and building $*.java file") EOL
PD PD emacs --batch --eval STRI("(setq *stump* \"$*\")") --load jtw-build-jtw.el --funcall doit EOL
EOL
FUNC(%.class:) FUNC(%.java) EOL
PD PD @echo STRI("* Stage 2 : Debugging *.java and building *.class file(s)") EOL
PD PD javac $(JAVAC_FLAGS) $$(find . -name STRI("*.java")) |& emacs --batch --eval STRI("(setq *stump* \"$*\")") --load jtw-javac.el --funcall doit \ EOL
|& grep STRI("input[0-9]:") - \ EOL
|& sed -e STRI("s/input[0-9]://g") - EOL
EOL
FUNC(%.run:) FUNC(%.class) EOL
PD PD @echo STRI("* Stage 3 : Running $*.class File") EOL
PD PD java $(JAVA_FLAGS) $* \ EOL
|& emacs --batch --load jtw-java.el --funcall doit \ EOL
|& grep STRI("input[0-9]*:") - \ EOL
|& sed -e STRI("s/input[0-9]*://g") - EOL
EOL
FUNC(build:) clean EOL
  m4_end_indent

  The first line FUNC(.PRECIOUS) without any arguments clears the list
  of precious files, the list of files not to delete during the build
  process.

  <a name="18.3"></a>SUBSECTION(18.3, Building a collection of classes
  or an entire PACKAGE)

  m4_ifelse(m4_index(SECT_BUILD,18.3),-1,[m4_errprint(error SECT build not equal)])

  When your CLASS CLSS(X) uses another CLASS CLSS(Y) which is in a
  different file from the CLSS(X) CLASS, then you need to add to the
  TT(build) target which is initially like so:

  m4_begin_indent
FUNC(build:) clean
  m4_end_indent

  to what follows:

  m4_begin_indent
FUNC(build:) clean BO(Y.java)
  m4_end_indent

  If your class CLSS(Y) is in another PACKAGE such as the CLASS
  GRY(~/jtw-tutorials/path/to/dir/Y.class) i.e. in the PACKAGE
  TT(path.to.dir) then you need to add to the build target like so:

  m4_begin_indent
FUNC(build:) clean BO(path/to/dir/Y.java)
  m4_end_indent

  This process should be repeated for every CLASS that is called,
  directly or indirectly from your MAIN CLASS CLSS(X).  This process
  can be applied to build an entire package when you simply issue the
  command TT(make build).  To actually build and run the CLSS(X)
  CLASS, let GRY(~/jtw-tutorials/path2/to/dir/X.class) be the location
  of the CLSS(X) CLASS.  Then you need to invoke the following
  TT(Makefile) target:

  m4_begin_indent
make build GRN(path2/to/dir/X.run)
  m4_end_indent

  The build target calls the "TT(BO(clean))" target which deletes all
  TT(BO(*.java)) and GRY(*.class) files directly or indirectly in the
  folder TT(~/jtw-tutorials).  If you don't do this then TT(BO(java))
  might run an old version of GRY(*.class) files despite earlier errors
  in the build process. This is because the use of pipes in building and
  executing GRY(*.class) files hides the return values of the programs
  TT(BO(javac)) and TT(BO(java)).

  SUBSECTION(18.4, Running JAVADOC on a PACKAGE)

  NI()To invoke TT(javadoc), you need to issue the following command
  from the folder TT(~/jtw-tutorials):

  m4_begin_indent
make build
  m4_end_indent

  NI()See SECT_BUILD for more information about setting up the
  TT(build) target.  Then you need to issue the following command from
  the folder TT(~/jtw-tutorials):

  m4_begin_indent
javadoc path3/to/pkg -d /path4/to/dir
  m4_end_indent

  where TT(path3.to.pkg) is the name of the package that you want to
  build (in the location TT(TILDE/jtw-tutorials/path3/to/dir)) and
  TT(/path4/to/dir) is the desired location for your documentation
  files in TT(*.html) format.

</p>

m4_changequote(,)
m4_changequote([,])
m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#18])


