m4_define([FCOD],[TT($*)])
m4_dnl m4_define([KB],<span class="kb"><code>$1</code></span>)
m4_dnl m4_define([KB],[<span class="red">TT(<b>$1</b>)</span>])

m4_define([m5_download_links],
[
<h2>1. Installing software on GNU/Linux systems</h2>

<p>
  See the following link for
  AHREF(http://www.debian.org/misc/children-distros, a list of
  GNU/Linux systems that derive from Debian).  The list includes
  EM(Ubuntu) (see WEBSITE(ubuntu.com)) the flavour of GNU/Linux that I
  choose to use.  For GNU/Linux systems that derive from Debian, the
  following command installs the TT(X) package: TT(sudo apt-get
  install X).  To install GNU Emacs version 24, you should issue the
  following command TT(sudo apt-get install emacs24).  Note that you
  will be prompted for the BO(root) password.  m5_mandatory

</p>

<h2>2. Installing software on M.S. Windows systems</h2>

<p>
  The following links are only valid for Microsoft Windows Systems,
  versions XP or higher.
</p>

<center>
  <table border=0 width="100%" cellpadding=10>
    <tr>
      <td valign=top align=right>
        m4_dnl <img src="m4_home/download-links/icon-emacs.jpg" width=64 height=64>
        <img src="m4_home/gnu-head-64x64.png" width=64 height=64 alt="Emacs Icon">
        m4_dnl <img src="m4_home/download-links/icon-emacs.png" width=64 height=63 alt="Icon Emacs">
      </td>
      <td valign=top align=left>

        m4_ifdef([m5_debugging],<p>RED(FTP directory =) WEBSITE(ftp.gnu.org/pub/gnu/emacs/windows)</p>)
        m4_ifdef([m5_debugging],<p>RED(FTP README =) WEBSITE(ftp.gnu.org/gnu/windows/emacs/README)</p>)

        <p>
          AHREF(http://www.gnu.org/software/emacs/,GNU Emacs) is the
          editor that is m5_required for use with this course.  You
          can AHREF(http://ftp.gnu.org/pub/gnu/emacs/windows/,
          download m5_emacs_version or a later version from APOS(GNU)s
          Website).  The file size is approximately 40 Megabytes.  You
          can also
          <a href="http://davinpearson.nz/binaries/dlisp.tar.gz">
          download my personal customizations to Emacs</a>.  The file
          size is approximately 1 Megabyte.  To install my
          customizations to Emacs, you will need complete the
          following actions:
        </p>

        <ol>
          <li>Set the environment variable FCOD(HOME) to a sensible
          value for your system.  Sensible values include:

          <ul>

            <li>FCOD(d:/home) (because the "d" drive on my system is
            my second hard drive) or

            <li>FCOD(c:/home) if you only have one hard drive or

            <li>FCOD(c:/Users/Davin Pearson/My Documents), where you
            replace the name TT("Davin Pearson") with your own name.
            This matches the same folder used by Windows 7 and later
            for storing your own files.  Under Windows XP and earier
            versions of M.S. Windows, you will need to use the
            following link: FCOD(c:/Documents and Settings/Davin
            Pearson/My Documents).

          </ul>

          <p>
            It is important that the TT(HOME) folder actually exists,
            so you can put your TT(.emacs) file into it.  If you don't
            set the FCOD(HOME) variable, it will default to TT(c:/).
            This is not desirable however since a whole heap of UNIX
            files e.g. TT(.*) (files beginning with a period) will
            crowd the root directory of your primary hard drive.
          </p>

          <li>Extract the FCOD(dlisp) folder to your FCOD(HOME) folder.

          <li>Copy the file FCOD(dlisp/school-emacs.el) to
          FCOD(.emacs) in your FCOD(HOME) folder by issuing the
          following MS-DOS command from your FCOD(HOME) folder:
          </li>

          <blockquote>
            TT(copy dlisp\school-emacs.el .emacs)
          </blockquote>

        </ol>

        You can view
        AHREF(http://www.gnu.org/software/emacs/windows/ntemacs.html,
        a FAQ that explains how to use Emacs on Windows Machines.)

      </td>
    </tr>
    <tr>
      <td valign=top align=right>
        <img src="m4_home/download-links/icon-cygwin.png" width=64 height=64 alt="Icon Cygwin">
      </td>
      <td valign=top align=left>

        <p>
          The AHREF(http://www.cygwin.com,Cygwin) Unix emulation
          package is used with this course.  Specifically, the following
          programs are needed:

          m4_dnl AHREF(http://www.perl.org/, perl),
          m4_dnl AHREF(http://www.gnu.org/software/m4, m4),
          AHREF(http://www.gnu.org/software/make, TT(make)),
          AHREF(http://www.gnu.org/software/bash, TT(bash)),
          AHREF(http://www.gnu.org/software/fileutils, TT(rm)),
          m4_dnl AHREF(http://www.gnu.org/software/fileutils, TT(cp)),
          AHREF(http://www.gnu.org/software/sed, TT(sed)),
          AHREF(http://www.gnu.org/software/grep, TT(grep)),
          AHREF(http://en.wikipedia.org/wiki/OpenJDK, TT(javac) and
          TT(java)).  You can
          AHREF(http://www.cygwin.com/setup.exe, download the Cygwin
          installer module) to download.  File size is approximately
          300 kilobytes but that actual download size will be larger,
          depending on what features you choose to install.  You
          should only need to install the minimum Cygwin functionality
          to use the features mentioned above.
        </p>

      </td>
    </tr>
    m4_ifdef([m5_irfanview],[
    <tr>
      <td valign=top align=right>
        <img src="m4_home/download-links/icon-irfanview.jpg" width=64 height=64 alt="Icon Irfanview">
      </td>
      <td valign=top align=left>

        <p>
          The AHREF(http://irfanview.com/,Irfanview) graphics
          manipulation program.  You
          can AHREF(http://irfanview.com/main_download_engl.htm,download)
          the installer module.  The file size is approximately 900
          kilobytes.  Note that this program is only available on
          Windows.
        </p>
      </td>
    </tr>])
    m4_ignore(
    <tr>
      <td valign=top align=right>
        m4_dnl <img src="capslock-717174-small.jpg" width=219 height=132>
        m4_dnl (/ 219 2) 109
        m4_dnl (/ 132 2) 66
        m4_dnl <img src="capslock-717174-small.jpg" width=109 height=66>
        <img src="m4_home/download-links/no-caps-lock.png" width=64 height=64 alt="No caps lock">
      </td>
      <td valign=top align=left>
        <p>
          Caps Lock disabler which turns the Caps Lock key into a
          Control Key.  This is useful because Emacs uses the Control
          Key for lots of things and Emacs commands like KB(Alt-u)
          (Up-case Current Word) and KB(Alt-l) (Down-case Current Word)
          renders the Caps Lock key obsolete.  Visit the following
          Website to find registry files that disable Caps Lock:
          WEBSITE(johnhaller.com/jh/useful_stuff/disable_caps_lock/)
        </p>
      </td>)
    </tr>
  </table>
</center>

<h2>3. Installing Davin's Full Version of GNU Emacs</h2>

If you haven't installed EM(Davin's Full Version of GNU Emacs) then
here is how you go about it: First, download the following tarball
(also known as a EM(compressed archive file))
<a href="http://davinpearson.nz/binaries/dlisp.tar.gz">
TT(davinpearson.nz/binaries/dlisp.tar.gz)</a>.  The TT(d) in
TT(dlisp) stands for <u>D</u>avin' version of TT(elisp), i.e. EM(Emacs
Lisp).  Untar the tarball using the program TT(tar) or, alternatively
EM(WinZip), to your TT(HOME) folder and add the following line of code
to your TT(.emacs) file: TT((load-file STRI("~/dlisp/d-start.el"))).
The TT(dlisp) package works equally well on GNU/Linux systems and
M.S. Windows systems.

<br>
<br>
])



