m4_define([KEY],[<tr><td width="50%" align=left>$1</td><td width="50%" align=left>$2</td></tr>])
m4_define([TABLESTUFF], border=1 width="75%" cellpadding=10)
m4_define([FCOD],<code>TT(<b>$1</b>)</code>)

m4_define([m5_how_to_use_emacs],
[<center>

  <table width="75%">
    <tr>
      <td align=left>

        <p>

          m4_ifelse(m5_required,required,[For the purpose of this
          course it is required that you have installed the GNU Emacs
          text editor.  Even if you APOS(don)t use GNU Emacs as your
          editor, GNU Emacs is needed to build TT(BO(*.java)) files
          from TT(*.jtw) files],[For the purpose of this course it it
          recommended that you use either <a
          href="http://davinpearson.com/binaries/dlisp.tar.gz">
          APOS(Davin)s full version of GNU Emacs</a> or simply GNU
          Emacs plus APOS(Davin)s <a href="jtw-mode.el">TT(jtw-mode.el)</a>
          so that you get CLSS(syntax) FUNC(highlighting) of
          H.T.M.L. and m4 code and automatic indentation of
          H.T.M.L. and m4 code.])

          For more detailed tutorials on how to use Emacs, simply press
          KB(F1) inside Emacs.  A small caveat applies to the on-line
          documentation accessed via the KB(F1) command: it explains how
          to use vanilla Emacs, i.e. a version that does not use my
          extensive customisations.  I have also simplified some of the
          terminology from the on-line manuals.

        </p>

        <br>

        <p>
          BO(Challenge to you:) If you APOS(don)t like any of the following
          keybindings then most of them can be redefined to whatever you
          prefer.
        </p>

      </td>
    </tr>
  </table>
</center>

<center>

  m4_define([COOL], [(Once you get used to it, you will wonder how you ever got by without it!)])

  <h2>Windows-Style Key Bindings</h2>

  <table width="75%">
    <tr>
      <td align=left>
        <p>
          Emacs does not support Windows-style key bindings by
          default, but I have altered my version of Emacs so that it
          does support the following Windows-standard key bindings:
        </p>
      </td>
    </tr>
  </table>

  <br>

  <table TABLESTUFF>

    KEY(KB(Control-o), [<u>O</u>pen file.  Similar to KB(Control-f) but
    opens a Windows file dialog box.  Not as fast as KB(Control-f) and
    cannot be used to open folders.])

    KEY(KB(Control-k), kill line.)

    KEY(KB(Control-y), yank from kill ring.)

    KEY(KB(Control-f), / KB(Control-d) Find <u>f</u>ile/<u>d</u>irectory)

    KEY(KB(f8), Undo / Redo the last change.)

    KEY(KB(Shift-Up) or KB(Shift-Down), Marks a region of text)

    KEY(KB(Delete),  [While a region is highlighted, deletes that region])

  </table>

  <h2>Other Important Key Bindings</h2>

  <table TABLESTUFF>

    KEY(KB(Control-x Control-s), <u>S</u>ave currently edited file.)

    KEY(KB(Control-x s), <u>S</u>ave all unsaved files.)

    KEY(KB(Control-x Control-c), Quit emacs.)

    KEY(KB(Control-x Control-w), Save the current file as a different
    file name.  Note that you will be prompted for the file name).

    KEY(KB(Control-x k), <u>K</u>ill the current file (asks to confirm if
    the current file APOS(hasn)t been saved).)

    KEY(KB(Insert), [Electric buffers menu (BO(Note:) Buffer &asymp;
    File). COOL The KB(F12) key also does the same thing.  One common
    usage of the Electric Buffers Menu is to toggle between the
    current and the next-to-current file using the key sequence
    KB(Insert Insert).  Note that the EM(Buffers Menu) at the top of
    the screen does a similar thing.])

    KEY(KB(Control-s), Incremental <u>S</u>earch forward.)
    KEY(KB(Control-r), Incremental <u>R</u>everse search.)
    KEY(KB(Alt-%) actually KB(Alt-Shift-5), Search and Replace.)
    KEY(KB(Alt-*) actually KB(Alt-Shift-8), Regexp search and replace.)
    KEY(KB(Alt-/), Automatically complete abbreviation. COOL)
    KEY(KB(Esc Esc Esc) or KB(Control-q), Abort current command and widen narrowed buffer.)
  </table>

  <h2>Function Key Bindings</h2>

  <table TABLESTUFF>
    KEY(KB(F1), Online help.)

    KEY(KB(Shift F1), Copy the contents of the current buffer to the clipboard.)

    KEY(KB(F2), Save all buffers that you are currently editing (no questions asked).)

    KEY(KB(F3), Save and delete non-essential buffers (no questions asked).  This is
    useful when you are editing a whole bunch of files and you wish to purge them all to disk.)

    KEY(KB(F4), Widen (the opposite of KB(Control-2) and KB(Control-3)).)

    KEY(KB(F5) or KB(Control-Alt-\), Automatically indents the whole
    buffer (see tutorial 2).))

    KEY(KB(F6), Opens a file using the Windows open file dialog box.
    This is the same as the key sequence KB(Control-o).)

    KEY(KB(F7), Toggles the current APOS(file)s read-only status.
    Note that files in the FCOD(output) folder are set to be read-only
    by default.  This device is intended to protect the user from
    editing files that they APOS(shouldn)t be editing.  If you really want
    to edit a file that you APOS(shouldn)t simply press this key and it
    opens up the possibility of editing that file.)

    KEY(KB(F8), Undo / Redo.)
    KEY(KB(F9), Compile using the last compile command.)
    KEY(KB(Control-F9) or KB(Alt-F9) or KB(Shift-F9), Compile and edit the command line.)

    m4_ifdef([m5_clever_shifting],[

    KEY(KB(F10),

    If you are currently viewing an TT(H.T.S.) m4 source file this key
    uses some cleverness to locate the corresponding TT(H.T.M.L.) file.

    If you are currently viewing an TT(H.T.M.L.) file this key
    loads the page into a web browser. COOL
    )

    KEY(KB(Control-F10) or KB(Alt-F10) or KB(Shift-F10),[

    This key sequence only applies to tutorials 4 and 7.  If you are
    currently viewing an TT(H.T.M.L.) source file this key uses some
    cleverness to locate the corresponding TT(H.T.S.) m4 source
    file. COOL

    BO(NOTE:) These commands KB(F10) and (KB(Control-F10) or
    KB(Alt-F10) or KB(Shift-F10)) are opposites.  To understand
    this, consider the following diagram:

    <img src="m4_home/how-to-use-emacs/clever.png" width=527 height=282 alt="Clever use of Emacs">

    ])])

    KEY(KB(Shift F11), Auto complete file name. COOL Note that
    KB(F11) by itself is bound under AHREF(http://lubuntu.net,
    Lubuntu) to toggle maximisation of the current window.)

    KEY(KB(F12), Electric buffers menu. COOL The KB(Insert) key also
    does the same thing.  One common usage of the Electric Buffers
    Menu is to toggle between the current and the next-to-current file
    using the key sequence KB(F12 F12).)

  </table>

  <h2>Miscellaneous Key Bindings</h2>

  <table TABLESTUFF>
    KEY(KB(Alt-u), Change current word to uppercase.)
    KEY(KB(Alt-l), Change current word to lowercase.)
    KEY(KB(Alt-c), Capitalise current word.)
    KEY(KB(Alt-q), Reformat paragraph to the width of the current value of the TT(fill-column) variable.)
  </table>

  <h2>Cutting and Pasting Text I</h2>

  <table TABLESTUFF>
    KEY(KB(Control-k), Kill line and append to last kill.)
    KEY(KB(Control-y), Yank last kill.)
    KEY(KB(Alt-y) [,] immediately following KB(Control-y), searches killed text. Each time you press this key it goes back one step through the "kill ring".)
    KEY(KB(Control-Backspace) or KB(Alt-Backspace), Backward delete word. COOL)
    KEY(KB(Control-Delete) or KB(Alt-Delete), Forward delete word. COOL)
  </table>

  <h2>Cutting and Pasting Text II</h2>

  <table TABLESTUFF>
    KEY(KB(Control-Space),      Push mark onto stack.)
    KEY(KB(Shift-Space),        Pop mark off stack.)
    KEY(KB(Control-x Control-x),Swap mark and point.)
    KEY(KB(Control-w),          Cut region between mark and point.)
    KEY(KB(Alt-w),              Copy region between mark and point.)
  </table>

  <h2>Splitting and Merging Windows</h2>

  <table TABLESTUFF>
    KEY(KB(Control-0), Delete this window.)
    KEY(KB(Control-1) or KB(F4), Delete all other windows.)
    KEY(KB(Control-2), Split window vertically.)
    KEY(KB(Control-3), Split window horizontally.)
    KEY(KB(Control-Tab), Other window.)

  </table>

  <h2>Navigating the Emacs Online "Info" Help System</h2>

  <table width="75%">
    <tr>
      <td>
        Note that the Emacs Info help system is operated much like a
        web browser.
      </td>
    </tr>
  </table>

  <br>

  <table TABLESTUFF>
    KEY(KB(n), <u>N</u>ext Info Page.)
    KEY(KB(p), <u>P</u>revious Info Page.)
    KEY(KB(l), <u>L</u>ast Info Page (same as the EM(back button) on a web browser).)
    KEY(KB(r), Same as the EM(forward button) on a web browser.)
    KEY(KB(d), [Returns to the main <u>D</u>irectory of all info pages,
    much like to EM(home button) on a web browser.])
  </table>

  <h2>Useful Keys for Debugging H.T.M.L. Documents</h2>

  <table TABLESTUFF>
    KEY(KB(Alt-;), Toggles tags
    (see <a href="m4_home/webdesign/tutorial-01.html">Webdesign
    Tutorial 1</a>).)

    KEY(KB(Control-Left) or KB(Alt-Left)<br>
    KB(Control-Right) or KB(Alt-Right), Finds matching bracket
    KB(&lt; &gt; &#40; &#41; &#91; &#93; &#123; &#125;)
    (see <a href="m4_home/webdesign/tutorial-01.html">Webdesign
    Tutorial 1</a>).)

    KEY(KB(Alt-x testlinks Enter), Debugs broken links
    (see <a href="m4_home/webdesign/tutorial-02.html">Webdesign
    Tutorial 2</a>).)

    KEY(KB(TAB), Automatically indents the current line
    (see <a href="m4_home/webdesign/tutorial-03.html">Webdesign
    Tutorial 3</a>).)

    KEY(KB(F5) or KB(Control-Alt-\), Automatically indents the whole
    buffer (see <a href="m4_home/webdesign/tutorial-03.html">Webdesign
    Tutorial 3</a>).))

    KEY(KB(Alt-x weblint Enter), Run the external program EM(weblint)
    to debug H.T.M.L. (see
    tutorial <a href="m4_home/webdesign/tutorial-03.html">Webdesign
    Tutorial 3</a>.))

  </table>
</center>

<br>])
