m4_dnl -*-html-*-
m4_dnl m4_define([TT],<font size="+2"><tt>$*</tt></font>)

<table cellspacing=10>
  <td>
    <img src="hit.png" alt="Sample code">
  </td>
  <td width=80% valign=top>

    <p>
      The following tutorials were written by Davin Pearson as
      supplementary material to the <a
      href="http://www.cosc.canterbury.ac.nz/teaching/classes/cosc121/"
      target=_top>University of Canterbury COSC121 course</a> teaching the
      Java language.  At the top of each tutorial is a hyperlink to a
      model answer, but don't look at the answer until you have completed
      all the questions of the tutorial!
    </p>

    <br>
    <p>

      RED(DISCLAIMER:) These tutorials were not developed by TEAM COSC and
      are independent any COSC course.  They are solely intended as a
      study aid.

    </p>

    <br>

    <p>
      When you have finished the tutorials, check out my Website:
    </p>

    <br>

    <center>
      <h1><a href="http://davin.50webs.com">davin.50webs.com</a></h1>
    </center>

  </td>
  <td>
    <img src="hit.png" alt="Sample code">
  </td>
</table>

<table cellpadding=8 border=1>

  <tr><th>Number</th><th>File(s)</th><th>Notes</th></tr>

  <tr>
    <th>1</th>
    <td>m4_file(PersonTest.java)</td>
    <td>

      Contains a simple class TT(Person) for representing the
      concept of a human being, and a driver class
      TT(PersonTest).

      Key concepts:
      <ul>
        <li> Defining and calling a method.
        <li> Defining and accessing a property.
        <li> Defining and calling a constructor.
      </ul>

    </td>
  </tr>

  <tr>
    <th>2</th>
    <td>m4_file(CitizenTest.java)</td>
    <td>

      Contains a class TT(Citizen) for storing a person's
      financial information including their salary, savings
      and loan (if they have one).  Tax is paid by the citizen
      and a class called TT(Government) is used to keep track
      of the total tax paid.  The classes are driven by
      TT(CitizenTest).

      Key concepts:
      <ul>
        <li>How to pass arguments into methods.
        <li>How to use a method's return value.
        <li>Ignoring the return value of a method.
        <li>Overloading two constructors.
        <li>Accessing a static property.
        <li>Calling a static method.
      </ul>

    </td>
  </tr>

  <tr>
    <th>3</th>
    <td>m4_file(DogTest.java)</td>
    <td>

      An example involving three classes TT(Flea), TT(Dog) and
      TT(DogOwner) to represent the idea that a dog has a flea
      and a dog-owner has a dog.  The class TT(DogTest) is the
      driver class.

      Key concepts:
      <ul>
        <li>A property of a class can itself be a
        reference to another class, setting up a
        relationship between the two classes.
      </ul>

    </td>
  </tr>

  <tr>
    <th>4</th>
    <td>m4_file(RunnerTest.java)</td>
    <td>

      Two classes TT(SportsShoe) and TT(Runner) for modelling
      runners and their shoes, together with a driver class
      called TT(RunnerTest).

      Key concepts:
      <ul>
        <li>Static methods versus non-static methods.
        <li>Overloading two methods.
        <li>Methods for swapping properties of two objects.
      </ul>

    </td>
  </tr>

  <tr>
    <th>5</th>
    <td>m4_file(StaticTest.java),m4_file(StaticTest2.java).</td>
    <td>
      This tutorial attempts to convey the meaning of the
      TT(static) keyword by showing firstly an example
      TT(StaticTest.java) where static is used and then
      secondly an example TT(StaticTest2.java) which is the
      same example with static removed.
    </td>
  </tr>

  <tr>
    <th>6</th>
    <td>m4_file(ForTest.java)</td>
    <td>
      This tutorial gives you practice in writing
      TT(for) loops.  A TT(for) loop has the following
      structure:

      <pre>
   for (<i>Init-part</i>; <i>While-part</i>; <i>Increment-part</i>)
   &nbsp;&nbsp;&nbsp;<i>Body-part</i>
      </pre>

      This tutorial shows you how the different parts of the
      TT(for) loop affect the behaviour of the loop.
    </td>
  </tr>

  <tr>
    <th>7</th>
    <td>m4_file(LoopTest.java)</td>
    <td>
      Java's three different looping constructs: TT(for),
      TT(do) and TT(while).  This tutorial takes you through
      the process of rewriting a TT(for) loop into a TT(do)
      loop and a TT(while) loop.
    </td>
  </tr>

  <tr>
    <th>8</th>
    <td>m4_file(ScrabbleTest.java)</td>
    <td>String manipulation.  Useful methods to remember are
      TT(length()) for getting a string's length, and
      TT(charAt(NNN)) for inspecting the character at location
      TT(NNN) in a string.
    </td>
  </tr>

  <tr>
    <th>9</th>
    <td>m4_file(ArrayTest.java),m4_file(ArrayTest2.java)</td>
    <td>

      <p>
        Arrays.  There are two kinds of arrays: arrays of
        references, and arrays of the built-in types.  The
        built-in types are: TT(int), TT(long), TT(short),
        TT(byte), TT(float), TT(double), TT(char) and
        TT(boolean).
      </p>

      <p>

        The file TT(ArrayTest.java) gives you practice using
        arrays of the built-in types, and the file
        TT(ArrayTest2.java) gives you practice using arrays of
        references.

      </p>
    </td>
  </tr>

  <tr>
    <th>10</th>
    <td>m4_file(CarTest.java).</td>
    <td>

      <p>
        Advanced tutorial involving two classes TT(Car), and
        TT(Driver) for representing automobiles and their
        owners, respectively.  Also the class TT(CarTest) is
        used for testing the other two classes.
      </p>

      <p>

        RED(WARNING:) Difficult tutorial.
      </p>

    </td>
  </tr>

  <tr>
    <th>11</th>
    <td>m4_file(TurtleTest.java)</td>
    <td>

      <p>
        Linked lists.  Dr Seuss' story <i>Yertle the Turtle</i>
        describes how a turtle called Yertle sits at the top of
        a pile of other turtles.  In this example, the pile of
        turtles is represented by a linked list of TT(Turtle)
        objects, with the TT(up) field serving to connect one
        TT(Turtle) object to another.  If a TT(Turtle) object
        has a non-TT(null) TT(up) field, then this represents a
        turtle that is sitting on top of the current one.  The
        last turtle in the linked list is the turtle that is at
        the top of the pile.
      </p>

      <p>
        RED(WARNING:) Difficult tutorial.
      </p>
    </td>
  </tr>

  <tr>
    <th>12</th>
    <td>m4_file(InheriTest.java)</td>
    <td>

      <p>
        Theoretical example of inheritance.  The file
        TT(InheriTest.java) contains four classes: TT(Animal),
        TT(Bird) and TT(Eagle) and a tester class
        TT(InheriTest).  Class TT(Bird) inherits from TT(Animal)
        and class TT(Eagle) inherits from TT(Bird).

      </p>
      <p>

        The main thing that this tutorial shows is the idea that
        inheritance is a non-symmetrical relationship.  For
        example: the TT(Bird) class inherits from the TT(Animal)
        class, which corresponds to the idea that "every bird is
        an animal".  The reverse, "every animal is a bird" is
        plainly not true! Inheritance forces you to recognize
        this.
      </p>

    </td>
  </tr>

  <tr>
    <th>13</th>
    <td>m4_file(StarWars.java)</td>
    <td>
      <p>
        Practical example of inheritance.
      </p>

      <p>
        The file TT(StarWars.java) is comprised of three
        classes: TT(XWing), TT(TieFighter) and TT(StarWars).
        The first two represent spacecraft from the two sides of
        the <em>Star Wars</em> films.  The class TT(StarWars)
        is the driver class and contains code for executing
        a battle between the X-Wings and the Tie Fighters.

      </p>

      <p>
        The tutorial shows how inheritance can
        be used to reduce the amount of duplication of code.
      </p>


    </td>
  </tr>

  <tr>
    <th>14</th>
    <td>m4_file(AnimalTest.java)</td>
    <td>Arrays, inheritance and polymorphism.</td>
  </tr>

</table>




