m4_dnl -*- html -*-
m4_divert(-1) m4_dnl
m4_rinclude(..,index.m4)

m4_define(LL,&lt;&lt;)
m4_define(RR,&gt;&gt;)
m4_define(GG,&gt;&gt;)
m4_define(LT,&lt;)
m4_define(LE,&lt;=)
m4_define(GT,&gt;)
m4_define(GE,&gt;=)
m4_define(ARROW,$1-&gt;)
m4_define(LTGT,<code>&lt;$1&gt;</code>)

m4_define(BRA,&#040;)
m4_define(KET,&#041;)
m4_define(operatorLL,operator&lt;&lt;)
m4_define(operatorGG,operator&gt;&gt;)

m4_define(INCLUDE,<code><b>include</b></code>)

m4_define([DEFUN],[<b>defun</b>])
m4_define([CLASS],<b>class</b>)
m4_define([TYPEDEF],<b>typedef</b>)
m4_define([TEMPLATE],<b>template</b>)
m4_define([PRIVATE],<b>private</b>)
m4_define([POBLIC],<b>public</b>)
m4_define([PROTECTED],<b>protected</b>)
m4_define([EXTENDS],<b>extends</b>)
m4_define([STATIC],<b>static</b>)
m4_define([VIRTUAL],<b>virtual</b>)
m4_define([OPERATOR],<b>operator</b>)
m4_define([GOTO],<b>goto</b>)
m4_define([BREAK],<b>break</b>)
m4_define([THIS],<b>this</b>)
m4_define([NEW],<b>new</b>)
m4_define([DELETE],<b>delete</b>)
m4_define([CONST_CAST],<b>const_cast</b>)
m4_define([FRIEND],<b>friend</b>)
m4_define([REINTERPRET_CAST],<b>reinterpret_cast</b>)
m4_define([RED],<span class="libd-red">$*</span>)
m4_define([NULL],RED(<b>null</b>))
m4_define([ASSORT],<b>ASSERT</b>($*))

m4_define(CONST,<b>const</b>)
m4_define(FINAL,<b>final</b>)
m4_define(VOID,CLSS(void))
m4_define(BOOL,CLSS(bool))
m4_define(CHAR,CLSS(char))
m4_define(INT,CLSS(int))
m4_define(DOUBLE,CLSS(double))
m4_define(UNSIGNED,CLSS(unsigned))
m4_define(STRING,CLSS(string))
m4_define(BOOLEAN,CLSS(boolean))

m4_define(SWITCH,<b>switch</b>)
m4_define(CASE,<b>case</b>)
m4_define(SIZEOF,<b>sizeof</b>($*))
m4_define(DU,<b>do</b>)
m4_define(WHILE,<b>while</b>)
m4_define(IF,<b>if</b>)
m4_define(ELSE,<b>else</b>)
m4_define(FUR,<b>for</b>)
m4_define(RETURN,<b>return</b>)

m4_dnl NOTE: DO is undefined as it is likely to occur on a word that shouldn't be changed:
m4_dnl
m4_dnl e.g. /* DO NOTHING */
m4_dnl

m4_dnl m4_define(DO,[m4_error(do undefined)])
m4_dnl m4_define(FOR,[m4_error(for undefined)])

m4_define([m5_where],[where TT(YYYY) is the year the file was last
modified, TT(mm) is the month the file was last modified and TT(dd) is
the day the file was modified and similarly for TT(HH), TT(MM) and
TT(SS)])

m4_define([m5_mopa2e],
[
<h2>Abstract</h2>

<p>
  I have used the EM(GNU Emacs) text editor for m5_emacs_years.
  During which time I have written m5_emacs_lines of EM(Emacs Lisp)
  code to customise the program so that it behaves BO(exactly) like
  how I want it to behave.  m5_mopa2e_supercedes This article presents
  m5_mopa2e_additions additions to Emacs (my most important
  customisations) that I have made in the form of
  m5_mopa2e_files <i>Emacs Lisp</i> (TT(*.el)) files.  The Lisp files
  presented in this document should work on all dialects of Emacs,
  including but not limited to <i>GNU Emacs</i> and <i>XEmacs</i>.
  Please <a href="m4_home/email.html">email me</a> if you encounter
  any problems installing these files in your local Emacs system.  The
  files linked to from this document fall under the
  AHREF(http://www.gnu.org/licenses/gpl-3.0.txt, <i> GNU General
  Public License</i>).  You can download
  <a href="http://davinpearson.com/binaries/dlisp.tar.gz">
  an archive file containing almost my entire Emacs
  customisations</a>.  The name of the tarball TT(dlisp.tar.gz)
  the <u>d</u> in TT(dlisp) stands for <u>D</u>avin's customizations
  to TT(elisp), i.e. EM(Emacs Lisp).  In the Emacs TT(*.el) source
  files that follow, the TT(d-) prefix stands for <u>D</u>avin's
  customisations.
</p>

<h2>1. How to install these features</h2>

<p>
  To install an arbitrary Emacs Lisp file TT(foo.el) to your own local
  Emacs system, simply copy TT(foo.el) to one of the folders
  pointed to by the variable TT(load-path) and add the line
  TT((require&nbsp;'foo)) to your TT(.emacs) file.  If you do not
  already have a TT(.emacs) file, create one in the folder that the
  environment variable TT(HOME) points to.  If your TT(HOME) variable
  is not set, as might be the case if you are using
  <i>Microsoft Windows</i> then the TT(HOME) folder will be TT(c:/).
  The trouble with this approach is that the root directory of your
  TT(c:/) drive will be cluttered with a whole heap of miscellaneous
  files, e.g. TT(.*) (files beginning with a period).  If you don't
  want this then you need to set it to a appropriate value for your
  system.  Examples of sensible values for TT(HOME) on Windows systems
  include TT(c:/home) or TT(d:/home) (if your TT(d:/) drive is a hard
  disk) or whatever.  It is important that the folder pointed to by
  TT(HOME) actually exists, so you can put your TT(.emacs) file into
  it.
</p>
])

m4_define([m5_motivation_for_the_program], [While I was in high school
I wrote a program in <i>Microsoft Amiga Basic</i> that could plot
arbitrary real-valued functions of a real-valued variable, which I
found useful to learn calculus.  As my understanding of computer
science was limited, it was necessary to change the source code of the
program every time you wanted to print a different function.  It is
only now with my greater understanding that I am able to revisit this
problem and rewrite the program in C++ so that it can compose
functions at run-time.])

m4_define([m4_mopa2e],[m4_errprint(mopa2e undefined)])

m4_define([m5_damtp_first],[This code has been submitted to the
AHREF(http://www.damtp.cam.ac.uk/user/sje30/emacs/ell.html, EM(Emacs
Lisp List)) at Cambridge University, England.])

m4_define([m5_damtp],[This code has been submitted to the Emacs Lisp List.])

m4_define([m4_top_address],<font color=white size=6 face=arial><b>davin.50webs.com/research</b></font>)

m4_define([m4_top_motto],<font color=white size="-1"><i>Bringing to you notes for the ages</i></font>)

m4_define([m4_top_logo],<img src="m4_home/gnu-head-64x64.png" width=64 height=64 alt="GNU">&nbsp;&nbsp;)

m4_define([m4_back_to_somewhere_href],[research/index.html])
m4_define([m4_back_to_somewhere_text],[Back to Research Projects])

m4_define([PP],<p>$*</p>)

m4_define([BEGINTT],<pre><span class="tt">)
m4_define([ENDTT],</span></pre>)

m4_divert m4_dnl
