m4_dnl m4_include(m4_home/../m4prefs.m4)
m4_dnl m4_define([m4_title],Course in Web Design)
m4_dnl m4_begin_html

<h2>1. Course material</h2>

m4_define([DONE],<span class="green"><b>All Done!</b></span>)
m4_define([SEMIDONE],<span class="green"><b>Semi Done!</b></span>)

m4_define([DONE])
m4_define([SEMIDONE])

m4_define([TARFILE],
[
m4_ifelse(m4_esyscmd(ls m4_home/../../output/davinpearson-com/binaries/webdesign-tutorial-$1.tar.gz),,,
<a href="http://davinpearson.com/binaries/webdesign-tutorial-$1.tar.gz">TT(webdesign-tutorial-$1.tar.gz)</a><br>)
])

m4_define([ANSWER_LINK_DEBUGGING],[m4_ifdef([m5_debugging],
[m4_define([DIR],m4_translit(m4_patsubst(m4_esyscmd(ls answer-$1-*.hts),hts,html),[
],))
m4_ifelse(DIR,,,<a href="DIR">Tutorial $1 Answers</a>)])])

m4_define([TUTORIAL],
[
<tr>
  <td>
    <a href="tutorial-$1.html">Tutorial $1 Questions</a><br>
    m4_ifdef([m4_doit],[TARFILE($1)])
    ANSWER_LINK_DEBUGGING($1)
  </td>
  <td>$2</td>
</tr>
]
)

<table border=1 cellpadding=10 align=center>

  m4_define([m4_doit])
  TUTORIAL(01, [
  <a name="1"></a>
  <ul>
    <li>Introduction to the GNU Emacs Editor</li>
    <li>Basic H.T.M.L. including:</li>

    <ul type=circle>
      <li>headings TAG(h1) DOTS TAG(h6), bold TAG(b), italics TAG(i) and paragraphs TAG(p).</li>
      <li>Line breaking tags TAG(p) versus TAG(br).</li>
      <li>Font tags: TAG(font size=... color=... face=...).</li>
      <li>Optional tags: TAG(html), TAG(head), TAG(title) and TAG(body).</li>
      <li>Alignment tags: TAG(center) and TAG(div).</li>
      <li>Miscellaneous tags: TAG(hr), TAG(sup) and TAG(sub).</li>
      <li>Problematic characters for H.T.M.L.: KB(&lt;), KB(&gt;), KB(&amp;), KB(&quot;), spaces and newlines.</li>
    </ul>
    <li>Using Emacs to navigate tags.</li>
    <li>Using Emacs to toggle commenting out tags.</li>
  </ul>])

  TUTORIAL(02,[
  <a name="02"></a>
  <ul>
    <li>Using Emacs to edit multiple files and folders.</li>
    <li>Hyperlinks from page 1 RAR page 2.</li>
    <li>Hyperlinks to sections in an H.T.M.L. document.</li>
    <li>Hyperlinks to Websites on the Internet.</li>
    <li>Image formats: BMP, GIF, JPG and PNG</li>
    <li>Adding images to an H.T.M.L. document.</li>
    <li>Hyperlinks directly to images</li>
    <li>Three possible image alignments.</li>
    <li>Debugging relative hyperlinks and image links with KB(Alt-x testlinks Enter).</li>
    <li>Editing images using IrfranView and MS Paint.</li>
    <li>Adding an image to the background of your Web page.</li>
    <li>Uploading a Website to TT(50webs.com)</li>
  </ul>
  ])

  m4_undefine([m4_doit])
  TUTORIAL(03,[
  <a name="03"></a>
  <ul>
    <li>Ordered and unordered lists: TAG(ul), TAG(ol) and TAG(li).</li>
    <li>Tables: TAG(table), TAG(tr), TAG(th), and TAG(td).</li>
    <li>Using percentage or pixel sizes.</li>
    <li>Tables inside tables (nested tables).</li>
    <li>Debugging/indenting tables using KB(TAB) or KB(F5) or
    KB(Control-Alt-\).</li>
    <li>Debugging H.T.M.L. tags using KB(Alt-x weblint Enter).</li>
  </ul>
  ])

  m4_define([m4_doit])
  TUTORIAL(04,[
  <a name="04"></a>
  <ul>
    <li>A simple introduction to m4.</li>
    <li>Multiple page Websites using m4 to generate navigation buttons.</li>
    <li>Using MCOD(make m4) to build Web pages.</li>
    <li>Using MCOD(make copy) to build images.</li>
    <li>Using MCOD(make tar) to backup a Website.</li>
    <li>Simple customisation of m4 content.</li>
    <li>Problematic characters for m4: KB(&#40;), KB(&#41;), KB(&#91;) and KB(&#93;) and KB(&#44;).</li>
  </ul>
  ])

  m4_undefine([m4_doit])
  TUTORIAL(05,[
  <a name="05"></a>
  <ul>
    <li>Advanced m4</li>
  </ul>])

  TUTORIAL(06,[
  <a name="06"></a>
  <ul>
    <li>Smart use of m4 to m5_reduce_tiresome.</li>
  </ul>
  ])

  m4_define([m4_doit])
  TUTORIAL(07,[
  <a name="07"></a>
  <ul>
    <li>Websites with sub-menus and sub-sub-menus to manage complexity</li>
    <li>Use of the M4([[m4_home]]) macro to refer to the home folder of a Website.</li>
    <li>Cascading Style Sheets (C.S.S.) and the TAG(span) tag rather than the TAG(font) tag</li>
    m4_dnl <li>Creating an icon image for your Website. </li>
    <li>Uploading a complex Website to TT(50webs.com).</li>
  </ul>
  ])

  TUTORIAL(08,[
  <a name="08"></a>
  <ul>
    <li>A simple introduction to P.H.P..</li>
    <li>Multiple page Websites using P.H.P. to generate navigation buttons</li>
    <li>Simple customisation of P.H.P. content.</li>
    <li>Smart use of P.H.P. to m5_reduce_tiresome</li>
  </ul>
  ])

  TUTORIAL(09,[
  <a name="09"></a>
  <ul>
    <li>Using P.H.P. to generate sub-menus and sub-sub-menus</li>
    <li>Cascading Style Sheets (C.S.S.) and the TAG(span) tag rather than the TAG(font) tag</li>
  </ul>])

  m4_undefine([m4_doit])
  TUTORIAL(10,[
  <a name="10"></a>
  <ul>
    <li>Design Your Own Website.</li>
  </ul>
  ])

  TUTORIAL(11,[
  <a name="11"></a>
  <ul>
    <li>Design Your Own Website II.</li>
  </ul>
  ])

</table>

<h2>2. Answers to questions</h2>

<a href="javascript:gateKeeper()" onClick="gateKeeper(); return false;">
These tutorials have answers but a password is required to access
them. Click on this paragraph to enter your password.
</a>

m4_noscript

<h2>3. Useful links</h2>

m4_define([CO],<code><b>$1</b></code>)

<table width="50%" border=1 cellpadding=10 align=center>
  <tr>
    <td>

      <ul>
        <li><a href="download-links.html">Download Links for Software Used in This Course</a>
        <li><a href="how-to-use-emacs.html">How to use Emacs</a>.
        <li><a href="html-ascii-codes.html">H.T.M.L. ASCII Codes 0 - 127</a>.
        <li><a href="decimal-hex-codes.html">Decimal/Hex Codes 0 - 255</a>.

        <li><a href="https://en.wikipedia.org/wiki/Lists_of_colors">Wikipedia's
        lists of colours</a>.

        <li>AHREF(http://firstsiteguide.com,TT(firstsiteguide.com)) is
        a link to a website provided to me by Duke Vukadinovic, email:
        m5_patch_email(duke@firstsiteguide.com).  Here is what he had
        to say about it:

        <blockquote>
          QQ(EM([I would like to introduce you to our educational
          website made for web beginners where we’ve included in-depth
          online guides together with downloadable PDF’s, video
          tutorials and a lot of other web development tools and
          resources in order to help newbies establish their online
          identity.]))
        </blockquote>

        <li>Elizabeth Turner m5_patch_email(elizabeth.o.turner@gmail.com)
        recommended to me the following Website:
        AHREF(http://www.reviews.com/web-hosting,
        www.reviews.com/web-hosting) and sent me the following email
        message:

        <blockquote>
          EM([We recently spent time investigating web hosting service
          providers. As I'm sure you know, consumers can have a
          difficult time finding a web hosting service that best suits
          their needs due to the overwhelming number of providers and
          options. Our team spent weeks researching over 200 top rated
          web hosting service providers by analyzing their services
          offering and coverage options. We even submitted support
          tickets, started chats, and made calls to 27 hosts in hopes
          of finding the best customer service among our
          contenders. Not only did we identify the leading providers,
          but we also created a comprehensive guide helping people
          better understand the most important aspects of web hosting
          services.])
        </blockquote>

        <li>Jessica Bini m5_patch_email(jessica@guru99.org) sent me the
        following email:

        <blockquote>
          EM([I just wanted to send you a quick email to let you know
          that we recently released an article on ASP.Net Tutorial
          AHREF(http://www.guru99.com/asp-net-tutorial.html,
          www.guru99.com/asp-net-tutorial.html).])
        </blockquote>

        <li>AHREF(http://validator.w3.org, W3.<small>ORG</small> H.T.M.L. Validator)
        <li>AHREF(m4_character_entities, Character entity references in H.T.M.L. 4).
        <li>AHREF(http://harrythecat.com/dorret/, Animated GIF Archive).

      </ul>

    </td>
  </tr>
</table>




