m4_undefine([RED])
m4_undefine([FUNC])

<p>
  m5_question([HINT(SECT_PROBLEMATIC_M4 Problematic Characters in m4) Recall that
  this is the code that should appear at the top of every TT(*.hts) file
  that you write:
</p>

m4_begin_center
<pre>
M4_INCLUDE(M4_HOME/../readonly.m4)
M4_DEFINE(SQ(M4_TITLE), <i>Page Title Goes Here</i>)
M4_BEGIN_HTML
</pre>
m4_end_center

<p>
  Now suppose you want to create a title that contains a comma, such
  as TT("Tom[,] Dick and Harry").  How should you do this? I can think
  of four ways, two ways using quotes, one using the <a
  href="html-ascii-codes.html">H.T.M.L. Ascii Code</a> for comma, and the
  fourth using the M4_COMMA_SINGLE macro from SECT_PROBLEMATIC_M4.])
</p>

m4_qests_equal(QEST_COMMA_IN_TITLE)

<p>
  m6_answer([
  <ul>
    <li>TT(M4_DEFINE(SQ(M4_TITLE), SQ(Tom&#44; Dick and Harry)))                                m4_dnl NOTE: fucked
    <li>TT(M4_DEFINE(SQ(M4_TITLE), Tom&#91;&#44;&#93; Dick and Harry))                          m4_dnl NOTE: fucked
    <li>TT(M4_DEFINE(SQ(M4_TITLE), Tom<span class=red><b>&amp;#44;</b></span> Dick and Harry))  m4_dnl NOTE: fucked
    <li>TT(M4_DEFINE(SQ(M4_TITLE), M4_COMMA(Tom) Dick and Harry))                               m4_dnl NOTE: fucked
  </ul>
  ])
</p>


<p>
  For each of the following questions you will need to calculate the
  output that m4 generates and then you will need to create an m4 source
  file and run m4 on it to verify that the result is what you expected.
  For each question you will need to create an m4 source file called
  <i>N</i>TT(.hts) for question number EM(N) with the following
  contents:
</p>

m4_begin_center
<pre>
M4_CHANGEQUOTE(BRA,KET)
M4_CHANGECOM
</pre>
m4_end_center

<p>
  m5_question([HINT(SECT_CONSTANTS Constants) Write some code to generate the
  following output.  Note that without quotes, m4 will evaluate this to
  nothing so you need to use quotes somewhere to prevent the evaluation
  of the M4_DEFINE_SINGLE command:
</p>

m4_begin_center
<pre>
M4_DEFINE(ABC,DEF)
</pre>
m4_end_center

<p>

  ])

</p>

<p>

  m6_answer([
  <ul>
    <li>TT(M4_DEFINE_SINGLE[[[(ABC,DEF)]]]) or                                            m4_dnl TODO: fucked
    <li>TT(SQ(M4_DEFINE(ABC,DEF)))
  </ul>])

</p>
<p>

  m5_question([HINT(SECT_CONSTANTS Constants II) Suppose we have the following code:

</p>

m4_begin_center
<pre>
M4_DEFINE(HAT, HAT)
</pre>
m4_end_center

<p>
  What does the above code do, assuming that TT(HAT) is undefined before
  this code?  After this code what is the result of evaluating TT(HAT)
  and TT(HAT(HELLO))?

  ])

</p>

<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(HAT) RAR TT(HAT).
    <li>TT(HAT) E2 TT(HAT) E2 TT(HAT)        m4_infinite_loop
    <li>TT(HAT(HELLO)) E2 TT(HAT) E2 TT(HAT) m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_CONSTANTS Constants III) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(HAT, SQ(HAT))
</pre>
m4_end_center

<p>
  What does the above code do, assuming that TT(HAT) is undefined before
  this code?  After this code what is the result of evaluating TT(HAT)
  and TT(HAT(HELLO))?

  ])

</p>

<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(HAT) RAR TT(HAT).
    <li>TT(HAT) E2 TT(HAT) E2 TT(HAT)        m4_infinite_loop
    <li>TT(HAT(HELLO)) E2 TT(HAT) E2 TT(HAT) m4_infinite_loop
  </ul>
  ])
</p>
<p>
  m5_question([HINT(SECT_CONSTANTS Constants IV) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(HAT, SQ(SQ(HAT)))
</pre>
m4_end_center

<p>
  What does the above code do, assuming that TT(HAT) is undefined before
  this code?  After this code what is the result of evaluating TT(HAT)
  and TT(HAT(HELLO))?

  ])

</p>

<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(HAT) RAR TT(SQ(HAT)).
    <li>TT(HAT) E2 TT(HAT).
    <li>TT(HAT(HELLO)) E2 TT(HAT).
  </ul>
  ])
</p>

<p>

  m5_question([HINT(SECT_CONSTANTS Constants V) Suppose we have the following code:

</p>

m4_begin_center
<pre>
M4_DEFINE(HAT, SQ(SQ(HAT $1)))
M4_DEFINE(CAT, DOG)
</pre>
m4_end_center

<p>

  What does the above code do, assuming that no macro definitions are
  in place before this code?  After this code what is the result of
  evaluating TT(HAT) and TT(HAT(CAT))?])

</p>
<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(HAT) RAR TT(SQ(HAT [$]1)).                                             m4_dnl NOTE: fucked
    <li>LINE 1: TT(CAT) RAR TT(DOG).
    <li>TT(HAT) E2 TT(HAT).
    <li>TT(HAT(CAT)) E2 TT(HAT DOG)
  </ul>
  ])
</p>

m4_dnl NOTE: ignore was here

<p>
  m5_question([HINT(SECT_CONSTANTS Constants VI) For this question
  assume that TT(M4_DEFINE(SQ(TREE),SQ(AAA $1 AAA))) has occurred so
  that TT(TREE) RAR TT(AAA $1 AAA).])

</p>

<p>
  m5_subquestion([Rewrite the following code using quotes so that it evaluates to
  TT(TREE(TREE(SEX))):
</p>

m4_begin_center
<pre>
TREE(TREE(SEX))
</pre>
m4_end_center

<p>
  ])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>TT(SQ(TREE(TREE(SEX))))
  </ul>
  ])

</p>

m4_dnl NOTE: ignore was here

<p>
  m5_subquestion([HARDQ Rewrite the following code using quotes so that
  it evaluates to TT(AAA TREE(SEX) AAA).
</p>

m4_sub_qests_equal(QEST_BUG)


m4_begin_center
<pre>
[TREE(TREE(SEX))]
</pre>
m4_end_center

<p>
  m4_ignore([
  <pre>
EVAL(TREE([TREE(SEX)]))   = IEVAL(IEVAL(TREE([TREE(SEX)])))
                          = IEVAL(IEVAL(MCALL(TREE,IEVAL([TREE(SEX)]))))
                          = IEVAL(IEVAL(MCALL(TREE,TREE(SEX))))
                          = IEVAL(IEVAL(AAA TREE(SEX) AAA))
                          = IEVAL(IEVAL(AAA) IEVAL(TREE(SEX)) IEVAL(AAA))
                          = IEVAL(AAA IEVAL(MCALL(TREE,IEVAL(SEX))) AAA)
                          = IEVAL(AAA IEVAL(MCALL(TREE,SEX)) AAA)
                          = IEVAL(AAA IEVAL(AAA SEX AAA) AAA)
                          = IEVAL(AAA IEVAL(AAA) IEVAL(SEX) IEVAL(AAA) AAA)
                          = IEVAL(AAA AAA SEX AAA AAA)
                          = IEVAL(AAA) IEVAL(AAA) IEVAL(SEX) IEVAL(AAA) IEVAL(AAA)
                          = AAA AAA SEX AAA AAA

EVAL(TREE([[TREE(SEX)]])) = IEVAL(IEVAL(TREE([[TREE(SEX)]])))
                          = IEVAL(IEVAL(MCALL(TREE,IEVAL([[TREE(SEX)]]))))
                          = IEVAL(IEVAL(MCALL(TREE,[TREE(SEX)])))
                          = IEVAL(IEVAL(AAA [TREE(SEX)] AAA))
                          = IEVAL(IEVAL(AAA) IEVAL([TREE(SEX)]) IEVAL(AAA))
                          = IEVAL(AAA TREE(SEX) AAA)
                          = IEVAL(AAA) IEVAL(MCALL(TREE, IEVAL(SEX))) IEVAL(AAA)
                          = AAA IEVAL(MCALL(TREE,IEVAL(MCALL(SEX)))) AAA
                          = AAA IEVAL(MCALL(TREE,IEVAL(DOG))) AAA
                          = AAA IEVAL(MCALL(TREE,DOG)) AAA
                          = AAA IEVAL(AAA DOG AAA) AAA
                          = AAA IEVAL(AAA) IEVAL(DOG) IEVAL(AAA) AAA
                          = AAA AAA DOG AAA AAA

NOTE: the above theoretical result clashes with the actual m4 result

NOTE: therefore there is a bug in my algorithm

NOTE: the rule for quoting constants superceeds my algorithm

  </pre>
  ])])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>TT(TREE(SQ(SQ(TREE(SEX))))) BO(Note:) there is a bug in my
    algorithm from SECT_MATHS_NERDS so that the output of my algorithm on
    this expression differs from the output of m4.
  </ul>
  ])
</p>

<p>
  m5_question([HARDQ HINT(SECT_CONSTANTS Advanced Constants) Rewrite to following macro:
</p>

m4_begin_center
<pre>
M4_DEFINE(HELLO, It costs $2)
</pre>
m4_end_center

<p>
  so that TT(HELLO) E2 TT("It costs $2") rather than TT("It costs")
  which it does now since the second argument to the TT(HELLO) macro is
  an empty string.  I can think of three ways to do this.  The first
  two ways use quotes and the second way uses the H.T.M.L. Ascii code
  for the dollar sign $. ])
</p>

<p>
  m6_answer([
  <ul>
    <li>TT(M4_DEFINE(SQ(It costs SQ(&#36;)2))) or
    <li>TT(M4_DEFINE(It costs SQ(SQ(&#36;2)))) or
    <li>TT(M4_DEFINE(It costs ENTY(&amp;#36;)2))
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_NAIVE_M4 Naive Use Of m4) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(SEX,SQ(APPLE))
M4_DEFINE(SEX,SQ(BANANA))
</pre>
m4_end_center

<p>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that no macro
  definitions are in place before this code?  After this code what is
  the result of evaluating TT(APPLE) and TT(BANANA) and TT(SEX)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(SEX) RAR TT(APPLE).
    <li>LINE 2: TT(APPLE) RAR TT(BANANA) (since TT(SEX) RAR TT(APPLE) in the line above).
    <li>TT(APPLE) E2 TT(BANANA).
    <li>TT(BANANA) E2 TT(BANANA).
    <li>TT(SEX) E2 TT(APPLE) E2 TT(BANANA).
  </ul>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that TT(SEX) RAR TT(DOG)
  before this code?  After this code what is the result of evaluating
  TT(APPLE) and TT(BANANA), TT(DOG) and TT(SEX)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(DOG) RAR TT(APPLE).
    <li>LINE 2: TT(APPLE) RAR TT(BANANA)
    <li>TT(APPLE) E2 TT(BANANA).
    <li>TT(BANANA) E2 TT(BANANA).
    <li>TT(DOG) E2 TT(BANANA).
    <li>TT(SEX) E2 TT(DOG) E2 TT(BANANA).
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_NAIVE_M4 Naive Use Of m4 II) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(FIGHTER, HERO)
M4_DEFINE(FIGHTER, BATH)
M4_DEFINE(BATH, STOP)
M4_DEFINE(BATH, ZIP)
</pre>
m4_end_center

<p>
  ])
</p>

<p>
  What does the above code do, assuming that no macro definitions are in
  place before this code?  After this code what is the result of
  evaluating TT(FIGHTER), TT(HERO), TT(BATH), TT(STOP) and TT(ZIP)?
</p>

<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(FIGHTER) RAR TT(HERO).
    <li>LINE 2: TT(HERO) RAR TT(BATH).
    <li>LINE 4: TT(BATH) RAR TT(STOP).
    <li>LINE 3: TT(STOP) RAR TT(ZIP).
    <li>TT(FIGHTER) E2 TT(HERO) E2 TT(BATH) E2 TT(STOP) E2 TT(ZIP).
    <li>TT(HERO) E2 TT(BATH) E2 TT(STOP) E2 TT(ZIP).
    <li>TT(BATH) E2 TT(STOP) E2 TT(ZIP).
    <li>TT(STOP) E2 TT(ZIP).
    <li>TT(ZIP) E2 TT(ZIP).
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_NAIVE_M4 Naive Use Of m4 III) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(RED,SQ(GREEN))
M4_DEFINE(GREEN, BLUE)
M4_DEFINE(ORANGE, RED)
M4_DEFINE(FUNC, HELLO $1)
</pre>
m4_end_center

m4_ignore(
<pre>
EVAL(define(RED,[[GREEN]]))  = nothing
                               IEVAL(RED) = RED
                               IEVAL([[GREEN]]) = [GREEN]
                               therefore sets RED RAR [GREEN]
EVAL(define(GREEN, BLUE))    = nothing
                               IEVAL(GREEN) = GREEN
                               IEVAL(BLUE)  = BLUE
                               therefore sets GREEN RAR BLUE
EVAL(define(ORANGE,RED))     = nothing
                               IEVAL(ORANGE) = ORANGE
                               IEVAL(RED) = IEVAL(MCALL(RED))
                                          = IEVAL([GREEN])
                                          = GREEN
                               therefore sets ORANGE RAR GREEN
EVAL(define(FUNC, HELLO $1)) = nothing
                               IEVAL(FUNC) = FUNC
                               IEVAL(HELLO $1) = IEVAL(HELLO) IEVAL($1)
                                               = HELLO $1
                               therefore sets FUNC RAR HELLO $1
EVAL(RED)                    = IEVAL(IEVAL(RED))
                             = IEVAL(IEVAL(MCALL(RED)))
                             = IEVAL(IEVAL([GREEN]))
                             = IEVAL(GREEN)
                             = BLUE
EVAL(GREEN)                  = IEVAL(IEVAL(GREEN))
                             = IEVAL(IEVAL(MCALL(GREEN)))
                             = IEVAL(IEVAL(BLUE))
                             = IEVAL(BLUE)
                             = BLUE
EVAL(BLUE)                   = IEVAL(IEVAL(BLUE))
                             = IEVAL(BLUE)
                             = BLUE
EVAL(ORANGE)                 = IEVAL(IEVAL(ORANGE))
                             = IEVAL(IEVAL(MCALL(ORANGE)))
                             = IEVAL(IEVAL(GREEN))
                             = IEVAL(IEVAL(MCALL(GREEN)))
                             = IEVAL(IEVAL(BLUE))
                             = IEVAL(BLUE)
                             = BLUE
EVAL(FUNC(ORANGE))           = IEVAL(IEVAL(FUNC(ORANGE)))
                             = IEVAL(IEVAL(MCALL(FUNC, IEVAL(ORANGE))))
                             = IEVAL(IEVAL(MCALL(FUNC, GREEN)))
                             = IEVAL(IEVAL(HELLO GREEN))
                             = IEVAL(IEVAL(HELLO) IEVAL(GREEN))
                             = IEVAL(HELLO IEVAL(MCALL(GREEN)))
                             = IEVAL(HELLO IEVAL(BLUE))
                             = IEVAL(HELLO BLUE)
                             = IEVAL(HELLO) IEVAL(BLUE)
                             = HELLO BLUE
</pre>
)

<p>
  What does the above code do, assuming that no macro definitions are
  in place before this code?  After this code what is the result of
  evaluating TT(RED), TT(GREEN), TT(BLUE), TT(ORANGE) and
  TT(FUNC(ORANGE))?])
</p>

<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(RED) RAR TT(GREEN).
    <li>LINE 2: TT(GREEN) RAR TT(BLUE).
    <li>LINE 3: TT(ORANGE) RAR TT(SQ(GREEN)).
    <li>LINE 4: TT(FUNC) RAR TT(HELLO $1).
    <li>TT(RED) E2 TT(BLUE).
    <li>TT(GREEN) E2 TT(BLUE).
    <li>TT(BLUE) E2 TT(BLUE).
    <li>TT(ORANGE) E2 TT(BLUE)
    <li>TT(FUNC(ORANGE)) E2 TT(FUNC(SQ(GREEN))) E2 TT(HELLO BLUE).
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_BINDING All Late Binding) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(BLACK),SQ(CAT))
M4_DEFINE(SQ(RED),SQ(GREEN BLUE))
M4_DEFINE(SQ(GREEN),SQ(BLACK))
M4_DEFINE(SQ(BLACK),SQ(PURPLE))
</pre>
m4_end_center

<p>
  What does the above code do, assuming that no macro definitions are in
  place before this code? After this code what is the result of
  evaluating TT(BLACK), TT(CAT), TT(RED), TT(GREEN), TT(BLUE) and
  TT(PURPLE)?])
</p>

<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(BLACK) RAR TT(CAT).
    <li>LINE 2: TT(RED) RAR TT(GREEN BLUE).
    <li>LINE 3: TT(GREEN) RAR TT(BLACK).
    <li>LINE 4: TT(BLACK) RAR TT(PURPLE) (replacing the definition in line 1).
    <li>TT(BLACK) E2 TT(PURPLE).
    <li>TT(CAT) E2 TT(CAT).
    <li>TT(RED) E2 TT(GREEN BLUE) E2 TT(BLACK BLUE) E2 TT(PURPLE BLUE).
    <li>TT(GREEN) E2 TT(BLACK) E2 TT(PURPLE).
    <li>TT(BLUE) E2 TT(BLUE).
    <li>TT(PURPLE) E2 TT(PURPLE).
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_BINDING Mostly Late Binding) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(APPLE),SQ(BANANA BANANA))
M4_DEFINE(SQ(BANANA),SQ(CARROT))
M4_DEFINE(SQ(DOUGHNUT),APPLE)
M4_DEFINE(SQ(EGG),SQ(APPLE))
M4_DEFINE(SQ(APPLE),SQ(SEX))
</pre>
m4_end_center

<p>
  What does the above code do, assuming that no macro definitions are in
  place before this code?  After this code what is the result of
  evaluating TT(APPLE), TT(BANANA), TT(CARROT), TT(DOUGHNUT), TT(EGG)
  and TT(SEX)?  Which of the above lines uses early binding?])
</p>

<p>
  m6_answer([
  The third line uses early binding.

  <ul>
    <li>LINE 1: TT(APPLE) RAR TT(BANANA BANANA).
    <li>LINE 2: TT(BANANA) RAR TT(CARROT).
    <li>LINE 3: TT(DOUGHNUT) RAR TT(CARROT CARROT). (early binding)
    <li>LINE 4: TT(EGG) RAR TT(APPLE).
    <li>LINE 5: TT(APPLE) RAR TT(SEX).
    <li>TT(APPLE) E2 TT(SEX).
    <li>TT(BANANA) E2 TT(CARROT).
    <li>TT(CARROT) E2 TT(CARROT).
    <li>TT(DOUGHNUT) E2 TT(CARROT CARROT).
    <li>TT(EGG) E2 TT(APPLE) E2 TT(SEX).
    <li>TT(SEX) E2 TT(SEX).
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_BINDING More Late Binding) Rewrite the following code to use late binding for the variable
  M4_BGCOLOR:
</p>

m4_begin_center m4_dnl NOTE: first one is wierd
<pre>
M4_DEFINE(SQ(M4_BEGIN_HTML),<b>&lt;html&gt;&lt;body bgcolor="M4_BGCOLOR"&gt;</b>)
M4_DEFINE(SQ(M4_END_HTML),HQ(</body></html>))
</pre>
m4_end_center

<p>
  ])
</p>

<p>
  m6_answer([
  <ul>
    <li>TT(M4_DEFINE(SQ(M4_BEGIN_HTML),SQ(<b>&lt;html&gt;&lt;body bgcolor="M4_BGCOLOR"&gt;</b>)))
    <li>The macro M4_END_HTML doesn't need to be changed.
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_SINGLE_MACRO_INFINITE_LOOPS Single Macro Infinite Loops I) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(FROG,FROG)
</pre>
m4_end_center

<p>
  ])
</p>

<p>

  m5_subquestion([What does the above code do, assuming that TT(FROG) is undefined
  before this code? After this code what is the result of evaluating
  TT(FROG)?])

</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(FROG) RAR TT(FROG).
    <li> TT(FROG) E2 TT(FROG) E2 TT(FROG) m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, What does the above code
  do, assuming that TT(FROG) RAR TT(DOG) before this code?  After this
  code what is the result of evaluating TT(DOG) and TT(FROG)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(DOG) RAR TT(DOG).
    <li>TT(DOG) E2 TT(DOG) E2 TT(DOG) m4_infinite_loop
    <li>TT(FROG) E2 TT(DOG) E2 TT(DOG) m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_SINGLE_MACRO_INFINITE_LOOPS Single Macro Infinite Loops II) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(FROG,SQ(FROG))
</pre>
m4_end_center

<p>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that TT(FROG) is undefined
  before this code?  After this code what is the result of evaluating
  TT(FROG)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(FROG) RAR TT(FROG).
    <li>TT(FROG) E2 TT(FROG) E2 TT(FROG) m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that TT(FROG) RAR TT(DOG)
  before this code?  After this code what is the result of evaluating
  TT(DOG) and TT(FROG)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(DOG) RAR TT(FROG).
    <li>TT(DOG) E2 TT(FROG) E2 TT(DOG) E2 TT(FROG)  m4_infinite_loop
    <li>TT(FROG) E2 TT(DOG) E2 TT(FROG) E2 TT(DOG)  m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_SINGLE_MACRO_INFINITE_LOOPS Single Macro Infinite Loops III) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(HOUSE,HOUSE HOUSE)
</pre>
m4_end_center

<p>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that TT(HOUSE) is undefined
  before this code?  After this code what is the result of evaluating
  TT(HOUSE)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(HOUSE) RAR TT(HOUSE HOUSE).
    <li>TT(HOUSE) E2 TT(HOUSE HOUSE) E2 TT(HOUSE HOUSE HOUSE HOUSE) m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that TT(HOUSE) RAR TT(MOUSE)
  before this code? After this code what is the result of evaluating
  TT(HOUSE) and TT(MOUSE)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(MOUSE) RAR TT(MOUSE MOUSE).
    <li>TT(HOUSE) E2 TT(MOUSE) E2 TT(MOUSE MOUSE) E2 TT(MOUSE MOUSE MOUSE MOUSE) m4_infinite_loop
    <li>TT(MOUSE) E2 TT(MOUSE MOUSE) E2 TT(MOUSE MOUSE MOUSE MOUSE)              m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_question([HINT(SECT_DOUBLE_MACRO_INFINITE_LOOPS Double Macro Infinite Loops) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(APPLE, SQ(BANANA))
M4_DEFINE(BANANA, SQ(APPLE))
</pre>
m4_end_center

<p>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that no macro
  definitions are in place before this code?  After this code what is
  the result of evaluating TT(APPLE) and TT(BANANA)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(APPLE) RAR TT(BANANA).
    <li>LINE 2: TT(BANANA) RAR TT(APPLE).
    <li>TT(APPLE) E2 TT(BANANA) E2 TT(APPLE) E2 TT(BANANA) m4_infinite_loop
    <li>TT(BANANA) E2 TT(APPLE) E2 TT(BANANA) E2 TT(APPLE) m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_subquestion([What does the above code do, assuming that TT(APPLE) RAR
  TT(YELLOW) and TT(BANANA) RAR TT(ZEBRA) before this code?  After this
  code what is the result of evaluating TT(APPLE), TT(BANANA),
  TT(YELLOW) and TT(ZEBRA)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(YELLOW) RAR TT(BANANA).
    <li>LINE 2: TT(ZEBRA) RAR TT(APPLE).
    <li>TT(APPLE) E2 TT(YELLOW) E2 TT(BANANA) E2 TT(ZEBRA) E2 TT(APPLE)  m4_infinite_loop
    <li>TT(BANANA) E2 TT(ZEBRA) E2 TT(APPLE) E2 TT(YELLOW) E2 TT(BANANA) m4_infinite_loop
    <li>TT(YELLOW) E2 TT(BANANA) E2 TT(ZEBRA) E2 TT(APPLE) E2 TT(YELLOW) m4_infinite_loop
    <li>TT(ZEBRA) E2 TT(APPLE) E2 TT(YELLOW) E2 TT(BANANA) E2 TT(ZEBRA)  m4_infinite_loop
  </ul>
  ])
</p>

<p>
  m5_question([HINT(Add To List I) Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(APPLE),BANANA)
M4_DEFINE(SQ(APPLE),APPLE CARROT)
M4_DEFINE(SQ(APPLE),APPLE DOUGHNUT)
</pre>
m4_end_center

<p>
  What does the above code do, assuming that no macro definitions are in
  place before this code?  After this code what is the result of
  evaluating TT(APPLE), TT(BANANA), TT(CARROT) and TT(DOUGHNUT)?])
</p>

<p>
  m6_answer([
  <ul>
    <li>LINE 1: TT(APPLE) RAR TT(BANANA).
    <li>LINE 2: TT(APPLE) RAR TT(BANANA CARROT) (replacing the above definition).
    <li>LINE 3: TT(APPLE) RAR TT(BANANA CARROT DOUGHNUT) (replacing the above definition).
    <li>TT(APPLE) E2 TT(BANANA CARROT DOUGHNUT).
    <li>TT(BANANA) E2 TT(BANANA).
    <li>TT(CARROT) E2 TT(CARROT).
    <li>TT(DOUGHNUT) E2 TT(DOUGHNUT).
  </ul>
  ])
</p>

<p>
  m5_question([HINT(Add To List II)])
</p>

<p>
  m5_subquestion([Suppose we have the following code:
</p>


m4_begin_center
<pre>
M4_IFDEF(SQ(APPLE),,SQ(M4_DEFINE(SQ(APPLE),SQ(BANANA))))
</pre>
m4_end_center

<p>
  What does the above code do, assuming that no macro definitions are
  in place before this code?  After this code what is the result of
  evaluating TT(APPLE) and TT(BANANA)?  Note that
  TT(M4(m4_ifdef)(A,B,C)) evaluates to TT(IEVAL(B)) if TT(IEVAL(A)) is
  defined and TT(IEVAL(C)) if TT(IEVAL(A)) is not defined.])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(APPLE) RAR TT(BANANA).
    <li>TT(APPLE) E2 TT(BANANA).
    <li>TT(BANANA) E2 TT(BANANA).
  </ul>
  ])
</p>

<p>
  m5_subquestion([Suppose we have the following code:
</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(APPLE),SQ(ROOSTER))
M4_IFDEF(SQ(APPLE),,SQ(M4_DEFINE(SQ(APPLE),SQ(BANANA))))
</pre>
m4_end_center

<p>
  What does the above code do, assuming that no macro definitions are in
  place before this code?  After this code what is the result of
  evaluating TT(APPLE), TT(BANANA) and TT(ROOSTER)?])
</p>

<p>
  m6_subanswer([
  <ul>
    <li>LINE 1: TT(APPLE) RAR TT(ROOSTER).
    <li>LINE 2: does nothing and evaluates to nothing.
    <li>TT(APPLE) E2 TT(ROOSTER).
    <li>TT(BANANA) E2 TT(BANANA).
    <li>TT(ROOSTER) E2 TT(ROOSTER).
  </ul>
  ])
</p>

<p>
  m5_question([HARDQ HINT(Add To List III) Using the last two
  questions to help you, use M4(m4_ifdef) to write a macro
  M4(m4_add_to_list) so that the following code:
</p>

m4_begin_center
<pre>
M4_ADD_TO_LIST(SQ(APPLE), BANANA)
M4_ADD_TO_LIST(SQ(APPLE), CARROT)
M4_ADD_TO_LIST(SQ(APPLE), DOUGHNUT)
</pre>
m4_end_center

<p>
  causes TT(APPLE) E2 TT(BANANA CARROT DOUGHNUT)])
</p>

<p>
  m6_answer([
  <ul>
    <li>TT(M4_DEFINE(SQ(M4_ADD_TO_LIST_SINGLE),SQ(M4_IFDEF(SQ($1),SQ(M4_DEFINE(SQ($1),$1 $2)),SQ(M4_DEFINE(SQ($1),$2))))))
  </ul>
  ])
</p>

<hr>

m4_define([m4_back_to_somewhere_href],[webdesign/index.html#5])
