
HTS_FILES = $(wildcard *.hts)
HTS_FILES_LESS_EXTENSION = $(patsubst %.hts,%,$(HTS_FILES))

M4_PREFS = -Dm4_home=$(m4_home) -Dm4_dirname=$(m4_dirname) -Dm4_filename=$$X.html

TARGET_DIR = $(m4_home)/../../output/$$(basename $$(cd $(m4_home); pwd))/$(m4_dirname)

m4:
	@echo "TARGET_DIR=" $(TARGET_DIR)
	mkdir -p $(TARGET_DIR)
	for X in $(HTS_FILES_LESS_EXTENSION); do m4 -P $(M4_PREFS) $$X.hts >$(TARGET_DIR)/$$X.html; done

copy:
	mkdir -p $(TARGET_DIR)
	for X in $(wildcard *.jpg *.gif *.css); do cp -upv $$X $(TARGET_DIR); done

clean:
	mkdir -p $(TARGET_DIR)
	for X in $(TARGET_DIR)/*; do rm -fv $$X; done

TIMESTAMP = $$(date.exe +"%Y%m%d-%H%M%S")

tar:
	X=$$(basename $$(pwd)); printf "X=%s\n" $$X; cd ..; tar cvf $(m4_home)/../$$X.tar $$X; gzip $(m4_home)/../$$X.tar; mv $(m4_home)/../$$X.tar.gz $(m4_home)/../$$X-$(TIMESTAMP).tar.gz

foo:
	@echo $$(basename $$(cd $(m4_home); pwd))
	@echo $(TARGET_DIR)
	@echo $(SHELL)




