
m4_define([m5_transfer],
[transfer the file to Ripway using the FTP command MCOD(put index.php) and look at the output in a Web browser])
m4_define([m5_Transfer],
[Transfer the file to Ripway using the FTP command MCOD(put index.php) and look at the output in a Web browser])
m4_define([m5_here],
[Here is some P.H.P. code that generates the same output as above])
m4_define([m5_add],
[Add the following code to FCOD(index.php)])
m4_define([m5_check],[and then check that your changes have been made
successfully by browsing your Website in a Web browser])

This tutorial explains how P.H.P. can be used to create navigation menus
at the top and bottom of every page in your Website.  If your Website
is large it is more efficient and practical to automate the process of
generating navigation menus rather than to manually code them using
H.T.M.L. code.  For example when you add a new page to your Website using
P.H.P. you only need to change two files compared with hundreds of H.T.M.L.
files when you have a large Website.  Recall from
SECT_INTRODUCTION_TO_EMACS the following diagram showing how Emacs,
Web pages, Ripway and Web browsers relate to one another.

<br>
<br>
<center>
  <img src="m4_defeat/diagram-html.png">m4_dnl width=467 height=192
</center>
<br>

The P.H.P. language changes the above to the following.  Note that
TT(50webs.com) does not support P.H.P. so you need to use Ripway for this
tutorial.

<br>
<br>
<center>
  <img src="m4_defeat/diagram-php.png">
</center>
<br>

<p align=justify>
  In this tutorial we will use the Ripway Web hosting service as it
  supports P.H.P. and TT(50webs.com) doesn't.  Note that files that end
  end with TT(.php) are Web pages that you can load into a Web
  browser.  File ending with TT(.inc) are data files that are for use
  by TT(.php) files and cannot be directly loaded into a Web browser.
  Note that P.H.P. files are created by the Web server before they are
  loaded into a Web browser.

</p>
<p align=justify>

  Note that unlike m4, P.H.P. does not support more than one folder.
  This means that every P.H.P. file that you create in a Website has to
  reside in the same folder.  Under m4, if you had a file TT(def) in
  the folder TT(abc), you need to name it like so in P.H.P.:
  TT(abc-def.php).  Note the use of prefixing to simulate multiple
  directories.  This is a bit annoying if your Website has lots of
  pages, but I cannot see any way around it.  If you can find a way
  around it, then please <a href="m4_home/email.html">email me</a>!

</p>

H2(Download the files for this tutorial)

<p align=justify>

  m5_question_unzip(08)

</p>

<hr>

H2(Debugging hyperlinks)

<p align=justify>

  m5_question([Run KB(Alt-x testlinks Enter) on the folder FCOD(tutorial-8)
  to verify that all of the links in that folder are
  valid.])

</p>

<hr>

H2(Create a TT(Ripway.com) account)

<p align=justify>

  m5_question([Open the following URL in a Web browser
  WEBSITE(www.50webs.com) and click on the BO(Sign Up) button.  Then
  fill in the form to create a Ripway account under your name.])

</p>

<hr>

H2(Upload your Website to TT(Ripway.com))

<p align=justify>

  m5_question_ftp(tutorial-8,the last question)

</p>

<hr>

H2(Customise your Website)

H3(Change H.T.M.L. code)

<p align=justify>

  m5_question([Change the TT(Main Main Main DOTS) text in the "index"
  page to something more appropriate by editing the file
  FCOD(index.php).  Save the file by pressing KB(F2), click on the FTP
  program and re-transfer the file using the FTP command MCOD(put
  index.php).  Then load FCOD(index.php) into a Web browser to check
  that your changes have been successfully made.])

</p>

<hr>

H3(About menu pages)

For every P.H.P. page PCOD(X.php) we will define the EM(menu page)
PCOD(M.inc) as follows:

<ol>

  <li>The menu page of FCOD(index.php) is FCOD(index.inc).

  <li>The menu page of FCOD(apple.php) is FCOD(index.inc).

  <li>The menu page of FCOD(apple-banana.php) is FCOD(apple.inc).

  <li>The menu page of FCOD(apple-banana-carrot.php) is FCOD(apple-banana.inc).

</ol>

Generally speaking if PCOD(n &ge; 2) then the menu page of
PCOD(SUB(F,1)-SUB(F,2)-SUB(F,3)-...-SUB(F,N).php) is
PCOD(SUB(F,1)-...-SUB(F,N-1).inc).  We make this definition because if
PCOD(X.php) is a page and PCOD(M.inc) is the menu page of PCOD(X.php),
then the code for the menu button for PCOD(X.php) is located in the
file PCOD(M.inc).

H3(How to add a single page)

<ol>

  <li>Let the name of the page that you want to add be denoted by
  FCOD(FILE.php).

  <li>Let the title of the page that you want to add be denoted by
  FCOD(TITLE).

  <li>Let FCOD(M.inc) denote the menu page of FCOD(FILE.php).

  <li>Create a page called FCOD(FILE.php) containing the following:

  m4_begin_indent
  <b>
    <pre>
&lt;?php

$file = "FILE.php";
$title = "TITLE";
include "M.inc";
include "root-second.inc";

?&gt;

<i>Your text for this page goes here</i>

&lt;?php
include "root-last.inc";
?&gt;

    </pre>
  </b>
  m4_end_indent

  <li>To the file FCOD(M.inc) add the following line:
  PCOD(button("FILE.php","TITLE");).

</ol>

<p align=justify>

  m5_question([Add a new page FCOD(carrot.php).  To be able to access
  the page, add a call to the PCOD(button) function in the menu page
  FCOD(index.inc).  Upload your changes using the FTP command MCOD(put
  carrot.php index.inc) and use a Web browser to check that the
  "Carrot" page has been added successfully.])

</p>

<p align=justify>
  m5_question([Add a curriculum vitae page called FCOD(cv.php).  Upload
  your changes using the FTP command MCOD(mput cv.php index.inc)
  m5_check.])
</p>

<hr>

H3(How to delete a single page) m4_sub_sects_equal(SECT_DELETE_A_PAGE)


Note that you cannot remove the page FCOD(index.php) because for your
Website to be viewable in a Web browser you must have at least this
page!

<ol>

  <li>Let the file of the page that you want to delete be denoted by
  FCOD(X.php).

  <li>Delete the file FCOD(X.php).  This will remove the page from
  your Website.

  <li>Let FCOD(M.inc) denote the menu page of FCOD(X.php).  In
  FCOD(M.inc) remove the line which says PCOD(button("X.php",...)).
  This will remove the FCOD(X.php) menu botton from every page of your
  Website.

</ol>

<p align=justify>

  m5_question([Delete the page FCOD(banana.php).  Upload your changes
  using the FTP commands MCOD(delete banana.php) and MCOD(put index.inc)
  and use a Web browser to check that the "Banana" page has been
  deleted successfully.])

</p>

<hr>

H3(Write some P.H.P. code)

<p align=justify>

  m5_question(Here are some questions concerning the use of P.H.P. variables:)

</p>
<p align=justify>

  m5_subquestion([m5_add:

</p>

m4_begin_indent
<pre>
<b>&lt;h1&gt;</b>apple banana carrot<b>&lt;/h1&gt;</b>
</pre>
m4_end_indent


<p align=justify>
  m5_Transfer.])
</p>
<p align=justify>

  m5_subquestion([m5_here. m5_add:

</p>

m4_begin_indent
<pre><b>
&lt;?php
echo "&lt;h1&gt;apple banana carrot&lt;/h1&gt;\n";
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  Note that in the above:

</p>

<ol>
  <li>P.H.P. code starts with PCOD(&lt;?php) and ends with PCOD(?&gt;)
  <li>The command PCOD(echo) writes H.T.M.L. code to the Web page,
  <li>Semi-colons PCOD(;) is needed at the end of every P.H.P. command
  <li>Double quotes PCOD(") DOTS PCOD(") denote a literal string
  <li>The symbol PCOD(\n) denotes the carriage return character
</ol>

<p align=justify>
  m5_Transfer])
</p>
<p align=justify>

  m5_subquestion([m5_here. m5_add:

</p>

m4_begin_indent
<pre><b>
&lt;?php
$x = "&lt;h1&gt;apple banana carrot&lt;/h1&gt;\n";
echo "$x";
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  Note that In the above, note that anything that starts with the
  PCOD($) sign is a P.H.P. variable, which is a space in your computer's
  memory for storing data. m5_Transfer.])

</p>
<p align=justify>

  m5_subquestion([m5_here.  m5_add:

</p>

m4_begin_indent
<pre><b>
&lt;?php
$x = "&lt;h1&gt;"
$x = $x . "apple";
$x = $x . " banana";
$x = $x . " carrot";
$x = $x . "&lt;/h1&gt;"
echo "$x";
?&gt;
</b></pre>
m4_end_indent

<p align=justify>
  In the above, note the use of the PCOD(.) operator which concatenates
  two shorter strings into one longer string. m5_Transfer.])
</p>
<p align=justify>

  m5_subquestion([m5_here.  m5_add:

</p>

m4_begin_indent
<pre><b>
&lt;?php
$x = "&lt;h1&gt;"
$x .= "apple";
$x .= " banana";
$x .= " carrot";
$x .= "&lt;/h1&gt;"
echo "$x";
?&gt;
</b></pre>
m4_end_indent

<p align=justify>
  In the above, note the use of the PCOD(.=) operator.  The expressiong
  PCOD($a .= $b) has the same effect as PCOD($a = $a . $b). m5_Transfer.])
</p>
<p align=justify>

  m5_subquestion([m5_here. m5_add:

</p>

m4_begin_indent
<pre><b>
&lt;?
$a = "apple";
$c = "carrot";
echo "&lt;h1&gt;$a banana $c&lt;/h1&gt;";
?&gt;
</b></pre>
m4_end_indent

<p align=justify>
  In the above, note the use of variables inside double-quoted
  strings.  m5_Transfer.])
</p>

<p align=justify>
  m5_question([Change the heading message TT(www.davinpearson.com) to
  something more appropriate to your Website.  You will need to edit
  the variable PCOD($logo) at the top of the file
  FCOD(tutorial-8/index.inc) to do this.  Save the file and upload
  your changes using the FTP command MCOD(mput *.inc) m5_check.])
</p>
<p align=justify>
  m5_question([Change title of FCOD(index.php) to something more
  appropriate for your Website.  Save the file and upload your changes
  using the FTP command MCOD(mput index.php) m5_check.])
</p>
<p align=justify>
  m5_question([Change the bottom copyright message to something
  suitable for your Website.  You will need to edit the COM(echo)
  command near to bottom of the file FCOD(tutorial-8/root-last.inc) to
  do this. Save the file and upload your changes using the FTP command
  MCOD(mput *.inc) m5_check.])
</p>
<p align=justify>

  m5_question([Add a call to the PCOD(newline();) function in between
  PCOD(button("apple.php",...)) and PCOD(button("banana.php",...)) in the
  file FCOD(index.inc) so that the navigation menus are two wide.  Save
  this file and upload your changes using the FTP command MCOD(put
  index.inc) m5_check.])

</p>
<p align=justify>

  m5_question([Add a logo and a motto that resembles the logo and
  motto that is at the top of this Web page.  Firstly you will need to
  save the silver fern to disk by right-clicking on the silver fern at
  the top of this Web page and selecting TT(Save Image As...)  menu
  item.  You will also need the edit the variable PCOD($logo) near the
  top of the file FCOD(index.inc).  You will need to use the
  TAG(table) and related tags like TAG(tr), TAG(td), as well as the
  TAG(font) and TAG(img) tags. Finally, save this file and upload your
  changes using the FTP command MCOD(mput *.jpg
  index.inc). m5_check.])

</p>

<p align=justify>

  m5_question([Add the following code PCOD($no_title=1;) to
  FCOD(apple.php) so that the title doesn't show up underneath the
  navigation menus at the top of the page.  Use the TAG(center) and
  TAG(h1) tags to get the title back online without removing the line
  of code that says PCOD($no_title=1;).])

</p>
<p align=justify>

  m5_question([Change the background colour of the menu buttons at the
  top of the screen to black and change the foreground colour of the
  menu buttons at the top of the screen to what was the background
  colour of the menu buttons.  To do this you will need to do some
  search and replace operations at the top of the file TT(index.inc):

</p>

<ul>
  <li>Replace PCOD($button_col_fglo) with PCOD($button_col_bglo)
  <li>Replace PCOD($button_col_fghi) with PCOD($button_col_bghi)
  <li>Replace PCOD($button_col_bglo) with PCOD($button_col_fglo)
  <li>Replace PCOD($button_col_bghi) with PCOD($button_col_fghi)
</ul>

<p align=justify>
  ])
</p>
<p align=justify>

  m5_question([Try editing the following variables to see what
  happens:

</p>

<ul>
  <li>PCOD($top_color)
  <li>PCOD($logo_font)
  <li>PCOD($logo)
  <li>PCOD($menu_font)
</ul>

<p align=justify>
  ])
</p>

<p align=justify>

  m5_question([Add a JPG image to the file FCOD(index.php) by getting
  an image off the Internet and displaying it using an TAG(img) tag in
  that file.  Save your changes and upload your changes using the FTP
  command MCOD(mput *.jpg index.php).  Note that it is essential that
  images are transmitted by FTP in TT(binary) transfer mode.
  Therefore before you send the files using the MCOD(mput) command, you
  should set binary transfer mode by issuing the FTP command MCOD(bin)
  (short for <u>bin</u>ary) m5_check.])

</p>
<p align=justify>

  m5_question([This question will guide you through the process of
  getting automatic numbering of sections and subsections.])

</p>
<p align=justify>

  m5_subquestion([Define a function TT(heading) in the file
  FCOD(index.php) so that the following P.H.P. code:

</p>

m4_begin_indent
<pre><b>
&lt;?php
  heading("apple");
  heading("banana");
  heading("carrot");
?&gt;
</b></pre>
m4_end_indent

<p align=justify>
  expands the the following H.T.M.L. code:
</p>

m4_begin_indent
HTML_QUOTE(
<h2>1. apple</h2>
<h2>2. banana</h2>
<h2>3. carrot</h2>
)
m4_end_indent

<p align=justify>
  BO(Hint:) The following code will help you. This code
</p>

m4_begin_indent
<pre><b>
&lt;?php
  $a = 0;
  function hello($argument)
  {
    global $a;
    $a = $a + 1;
    echo "hello $argument $a\n";
  }

  hello("apple");
  hello("banana");
  hello("carrot");
?&gt;
</b></pre>
m4_end_indent

<p align=justify>
  evaluates to
</p>

m4_begin_indent
<pre>
hello apple 1
hello banana 2
hello carrot 3
</pre>
m4_end_indent

<p align=justify>

  Note the use of the PCOD(global) keyword.  Without it PCOD($a) is a
  local variable to the function PCOD(hello) and therefore you get the
  following result:

</p>

m4_begin_indent
<pre><b>
hello apple 1
hello banana 1
hello carrot 1
</b></pre>
m4_end_indent

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([
</p>

m4_begin_center
<pre><b>
&lt;?php
  $heading = 0;

  function heading($title)
  {
    global $heading;
    $heading++;
    echo "&lt;h2&gt;$heading. $title&lt;/h2&gt;\n";
  }
  ?&gt;
</b></pre>
m4_end_center

<p align=justify>
  ])
</p>
<p align=justify>

  m5_subquestion([Then define a function PCOD(subheading) in the file
  FCOD(index.php) so that the following P.H.P. code:

</p>

m4_begin_indent
<pre><b>
&lt;?php
  heading("Apple");
  subheading("Banana");
  subheading("Carrot");
  subheading("Doughnut");
?&gt;
</b></pre>
m4_end_indent

<p align=justify>
  expands the the following H.T.M.L. code:
</p>

m4_begin_indent
HTML_QUOTE(
<h2>1. Apple</h2>
<h2>1.1. Banana</h2>
<h2>1.2. Carrot</h2>
<h2>1.3. Doughnut</h2>
)
m4_end_indent

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([

</p>

m4_begin_center
<pre><b>
&lt;?php

$heading = 0;

function heading($title)
{
  global $heading;
  $heading = $heading + 1;
  echo "&lt;h2&gt;$heading. $title&lt;/h2&gt;\n";
}

$subheading = 0;

function subheading($title)
{
  global $subheading,$heading;
  $subheading = $subheading + 1;
  echo "&lt;h3&gt;$heading.$subheading. $title&lt;/h3&gt;\n";
}
?&gt;
</b></pre>
m4_end_center

<p align=justify>
  ])
</p>
<p align=justify>

  m5_question([This teaches you how to write tutorials such as this
  one.  When writing tutorials it is convenient to keep questions and
  answers to those questions in the same file.  This question will
  teach you how to do this.])

</p>
<p align=justify>

  m5_subquestion([Put the following code in a file called FCOD(both.inc):

</p>

m4_begin_indent
<pre><b>
&lt;?php
QUESTION(1, "What is George Bernard Shaw's middle name?");
ANSWER(1, "Bernard");

QUESTION(2, "How do you spell H.T.M.L.?");
ANSWER(2, "H.T.M.L.");

QUESTION(3, "What is the square root of 144?");
ANSWER(3, 12);

QUESTION(4, "How many loaves are there in a baker's dozen?");
ANSWER(4, 13);

QUESTION(5, "What is the meaning of life?");
ANSWER(5, 42);
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  Create a file called FCOD(questions.php) with the following P.H.P. code
  in it:

</p>

m4_begin_indent
<pre><b>
&lt;?php
include "both.inc"
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  To the top of this file add definitions of P.H.P. functions
  PCOD(QUESTION) and PCOD(ANSWER) so that when you load FCOD(questions.php)
  into a Web browser you get the following H.T.M.L. code:

</p>

m4_begin_indent
<pre>
BO(&lt;p&gt;&lt;b&gt;Question 1:&lt;/b&gt;) What is George Bernard Shaw's middle name?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 2:&lt;/b&gt;) How do you spell H.T.M.L.?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 3:&lt;/b&gt;) What is the square root of 144?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 4:&lt;/b&gt;) How many loaves are there in a baker's dozen?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 5&lt;/b&gt;) What is the meaning of life?BO(&lt;p&gt;)
</pre>
m4_end_indent

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([Add the following code to the top of the file FCOD(questions.php)

</p>

m4_begin_center
<pre><b>
function QUESTION($number,$question)
{
  echo "BO(&lt;p&gt;&lt;b&gt;)Question $number:BO(&lt;/b&gt;) $question BO(&lt;p&gt;)\n";
}

function ANSWER($number,$answer)
{
   // do nothing
}
</b></pre>
m4_end_center

<p align=justify>
  In the above, note that from PCOD(//) to the end of the line denotes a
  comment.])
</p>
<p align=justify>

  m5_subquestion([Create a file called FCOD(answers.php) with the
  following P.H.P. code in it:

</p>

m4_begin_indent
<pre><b>
&lt;?php
include "both.inc"
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  To the top of this file add definitions of P.H.P. functions
  PCOD(QUESTION) and PCOD(ANSWER) so that when you load FCOD(answers.php)
  into a Web browser you get the following H.T.M.L. code:

</p>

m4_begin_indent
<pre>
BO(&lt;p&gt;&lt;b&gt;Question 1:&lt;/b&gt;) What is George Bernard Shaw's middle name? BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 1:&lt;/b&gt;) Bernard BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 2:&lt;/b&gt;) How do you spell H.T.M.L.?BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 2:&lt;/b&gt;) H.T.M.L. BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 3:&lt;/b&gt;) What is the square root of 144?BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 3:&lt;/b&gt;) 12 BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 4:&lt;/b&gt;) How many loaves are there in a baker's dozen?BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 4:&lt;/b&gt;) 13 BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 5&lt;/b&gt;) What is the meaning of life? BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 5:&lt;/b&gt;) 42 BO(&lt;p&gt;)
</pre>
m4_end_indent

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([Add the following code to the top of the file FCOD(questions.php)

</p>

m4_begin_center
<pre><b>
function QUESTION($number,$question)
{
  echo "BO(&lt;p&gt;&lt;b&gt;)Question $number:BO(&lt;/b&gt;) $question BO(&lt;p&gt;)\n";
}

function ANSWER($number,$answer)
{
  echo "BO(&lt;p&gt;&lt;b&gt;)Answer $number:BO(&lt;/b&gt;) $answer BO(&lt;p&gt;)\n";
}
</b></pre>
m4_end_center

<p align=justify>
  ])
</p>
<p align=justify>

  m5_subquestion([This question will extend on the previous two.  Put
  the following code in a file called FCOD(both2.inc):

</p>

m4_begin_indent
<pre><b>
&lt;?php
QUESTION("What is George Bernard Shaw's middle name?");
ANSWER("Bernard");

QUESTION("How do you spell H.T.M.L.?");
ANSWER("H.T.M.L.");

QUESTION("What is the square root of 144?");
ANSWER(12);

QUESTION("How many loaves are there in a baker's dozen?");
ANSWER(13);

QUESTION("What is the meaning of life?");
ANSWER(42);
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  Note that the file FCOD(both2.inc) differs from the earlier file that
  you created called FCOD(both.inc) in that the question and answer
  numbers are omitted.  Therefore they will have to be calculated
  using P.H.P. code.  Create a file called FCOD(questions2.php) with the
  following P.H.P. code in it:

</p>

m4_begin_indent
<pre><b>
&lt;?php
include "both2.inc"
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  To the top of this file add definitions of P.H.P. functions
  PCOD(QUESTION) and PCOD(ANSWER) so that when you load FCOD(questions2.php)
  into a Web browser you get the following H.T.M.L. code:

</p>

m4_begin_indent
<pre>
BO(&lt;p&gt;&lt;b&gt;Question 1:&lt;/b&gt;) What is George Bernard Shaw's middle name?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 2:&lt;/b&gt;) How do you spell H.T.M.L.?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 3:&lt;/b&gt;) What is the square root of 144?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 4:&lt;/b&gt;) How many loaves are there in a baker's dozen?BO(&lt;p&gt;)

BO(&lt;p&gt;&lt;b&gt;Question 5&lt;/b&gt;) What is the meaning of life?BO(&lt;p&gt;)
</pre>
m4_end_indent

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([Add the following code to the top of the file FCOD(questions2.php)

</p>

m4_begin_center
<pre><b>
$number = 0;

function QUESTION($question)
{
  global $number;
  $number = $number + 1;
  echo "BO(&lt;p&gt;&lt;b&gt;)Question $number:BO(&lt;/b&gt;) $question BO(&lt;p&gt;)\n";
}

function ANSWER($answer)
{
   // do nothing
}
</b></pre>
m4_end_center

<p align=justify>
  ])
</p>
<p align=justify>

  m5_subquestion([Create a file called FCOD(answers2.php) with the
  following P.H.P. code in it:

</p>

m4_begin_indent
<pre><b>
&lt;?php
include "both2.inc"
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  To the top of this file add definitions of P.H.P. functions
  PCOD(QUESTION) and PCOD(ANSWER) so that when you load FCOD(answers2.php)
  into a Web browser you get the following H.T.M.L. code:

</p>

m4_begin_indent
<pre>
BO(&lt;p&gt;&lt;b&gt;Question 1:&lt;/b&gt;) What is George Bernard Shaw's middle name? BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 1:&lt;/b&gt;) Bernard BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 2:&lt;/b&gt;) How do you spell H.T.M.L.?BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 2:&lt;/b&gt;) H.T.M.L. BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 3:&lt;/b&gt;) What is the square root of 144?BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 3:&lt;/b&gt;) 12 BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 4:&lt;/b&gt;) How many loaves are there in a baker's dozen?BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 4:&lt;/b&gt;) 13 BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Question 5&lt;/b&gt;) What is the meaning of life? BO(&lt;p&gt;)
BO(&lt;p&gt;&lt;b&gt;Answer 5:&lt;/b&gt;) 42 BO(&lt;p&gt;)
</pre>
m4_end_indent

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([Add the following code to the top of the file FCOD(answers2.php)

</p>

m4_begin_center
<pre><b>
$number = 0;

function QUESTION($question)
{
  global $number;
  $number = $number + 1;
  echo "BO(&lt;p&gt;&lt;b&gt;)Question $number:BO(&lt;/b&gt;) $question BO(&lt;p&gt;)\n";
}

function ANSWER($answer)
{
  global $number;
  echo "BO(&lt;p&gt;&lt;b&gt;)Answer $number:BO(&lt;/b&gt;) $answer BO(&lt;p&gt;)\n";
}
</b></pre>
m4_end_center

<p align=justify>
  ])
</p>
<p align=justify>

  m5_question([This question will guide you through the process of
  creating EM(smart comments) in P.H.P..  Smart comments differ from
  HQ(<!-- ... -->) comments in that they do not show up when you
  choose the m5_view_source_button in a Web browser.  To get smart
  comments online, you need to either write this P.H.P. code:

</p>

m4_begin_indent
<pre><b>
&lt;?php
/*
   This text does not show
   up in a Web browser's
   view (page) source button.
*/
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  or this P.H.P. code:

</p>

m4_begin_indent
<pre><b>
&lt;?php
//
// This text does not show
// up in a Web browser's
// view (page) source button.
//
?&gt;
</b></pre>
m4_end_indent

<p align=justify>

  Note that the symbols COMM(/* ... */) denote comments, just like
  COMM(//) to the end of the line.  Save this code in the file
  FCOD(index.php) and m5_transfer and the m5_view_source_button to be
  sure that smart comments do not show up.])
</p>
<p align=justify>

  m5_question([The following question will take you through
  the process of automatically generating tables from filename,
  width, height and caption information.])

</p>
<p align=justify>

  m5_subquestion([Define a P.H.P. function so that the following P.H.P. code:

</p>

m4_begin_indent
<pre><b>
&lt;table align=center&gt;
&lt;?php
   ENTRY("apple.jpg",  200, 186, "This is a picture of an apple.");
   ENTRY("banana.jpg", 200, 150, "This is a picture of a banana.");
   ENTRY("carrot.jpg", 200, 150, "This is a picture of a carrot.");
?&gt;
&lt;/table&gt;
</b></pre>
m4_end_indent

<p align=justify>
  expands to the following H.T.M.L. code:
</p>

m4_define([DEMO],
<table align=center>
  <tr>
    <td>
      <img src="apple.jpg" width=200 height=186 alt="apple">
    </td>
    <td>
      This is a picture of an apple.
    </td>
  </tr>
  <tr>
    <td>
      <img src="banana.jpg" width=200 height=150 alt="banana">
    </td>
    <td>
      This is a picture of a banana.
    </td>
  </tr>
  <tr>
    <td>
      <img src="carrot.jpg" width=200 height=150 alt="carrot">
    </td>
    <td>
      This is a picture of a carrot.
    </td>
  </tr>
</table>
)

TABLE_LEFT(HTML_QUOTE(DEMO))
TABLE_RIGHT(DEMO)

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([

</p>

m4_begin_center
<pre><b>
function ENTRY($filename,$width,$height,$caption)
{
  echo "&lt;tr&gt;&lt;td&gt;&lt;img src=$filename width=$width height=$height&gt;&lt;/td&gt;&lt;td&gt;$caption&lt;/td&gt;&lt;/tr&gt;\n";
}
</b></pre>
m4_end_center

<p align=justify>
  ])
</p>
<p align=justify>

  m5_subquestion([Then rewrite the macro so that the above text
  expands to the following:

</p>


m4_define([DEMO],
<table align=center>
  <tr>
    <td>
      <img src="apple.jpg" width=200 height=186 alt="apple"><br>
      <center>
        This is a picture of an apple.
      </center>
    </td>
  </tr>
  <tr>
    <td>
      <img src="banana.jpg" width=200 height=150 alt="banana"><br>
      <center>
        This is a picture of a banana.
      </center>
    </td>
  </tr>
  <tr>
    <td>
      <img src="carrot.jpg" width=200 height=150 alt="carrot"><br>
      <center>
        This is a picture of a carrot.
      </center>
    </td>
  </tr>
</table>)

TABLE_LEFT(HTML_QUOTE(DEMO))
TABLE_RIGHT(DEMO)
m4_dnl TABLE_RIGHT(<img src="tutorial-6-abc-2.jpg" width=219 height=564>)

<p align=justify>
  ])
</p>
<p align=justify>

  m6_subanswer([

  m4_begin_center
  <pre><b>
function ENTRY($filename,$width,$height,$caption)
{
  echo "&lt;tr&gt;&lt;td&gt;&lt;img src=$filename width=$width height=$height&gt;&lt;br&gt;&lt;center&gt;$caption&lt;/center&gt;&lt;/td&gt;&lt;/tr&gt;\n";
}
</b></pre>
m4_end_center

<p align=justify>
  ])
</p>
<p align=justify>

  m5_subquestion([What is the advantage in separating the logic from the layout? (As is
  done in the above two examples?)])

</p>
<p align=justify>

  m6_subanswer([The advantage if separating the logic from the layout is that it
  makes it easier to change to a different layout at a later stage.])

</p>
<p align=justify>

  m5_question([Add the following code to FCOD(index.php):

</p>

m4_begin_indent
<b>
  <pre>
  m4_include(tutorial-08-patch-email.inc)
  </pre>
</b>
m4_end_indent

<p align=justify>

  This function obfuscates email addresses so you don't get spammed
  when you post your email address to a Website.  For example calling
  PCOD(patch_email("adam@example.com");) writes the H.T.M.L. code HQ(adam
  <i>at</i> example <i>dot</i> com) to your Web page.  Don't forget to
  add the PCOD(&lt;?php ... ?&gt;) tags around the function so that
  it is interpreted as P.H.P. code.  Add some code that calls this
  function several times to verify that this function
  words. m5_Transfer.])

</p>
<p align=center>

  m6_answer([Here are some examples:

</p>

m4_begin_center
<b>
  <pre>
  &lt;?php patch_email(adam@example.com); ?&gt;
  &lt;?php patch_email(britney@example.net); ?&gt;
  &lt;?php patch_email(charles@example.org); ?&gt;
  </pre>
</b>
m4_end_center

<p align=justify>

  ])

</p>
<p align=justify>

  m5_question([Learn more about P.H.P. by studying the online tutorials
  at the following Website:
  WEBSITE(www.w3schools.com/php/default.asp).])

</p>
<p align=justify>

  m5_question([When you have finished this tutorial, you can
  quit the FTP program using the command MCOD(quit).])

</p>
<hr>

m4_define([m4_back_to_somewhere_href],[Webdesign/index.html#8])
