
ifdef IS_DOS
SHELL = c:/cygwin64/bin/bash.exe
else
SHELL = /bin/bash
endif

###
### assumes m4_home has been set.
###

WEBDATA = $(m4_home)/../..
BAK     = $(HOME)/Backups
BIN     = $(WEBDATA)/sources/Binaries

###
### assumes SOURCE_BASE and TARGET_BASE have been set.
###

TARGET_DIR =       $(TARGET_BASE)/$(m4_dirname)
SOURCE_DIR =       $(SOURCE_BASE)/$(m4_dirname)
TARGET_DIR_FILES = $(wildcard $(TARGET_DIR)/*.html)
SOURCE_SRC =       $(wildcard *.hts)
SOURCE_SRC_BASES = $(patsubst %.hts,%,$(SOURCE_SRC))
SOURCE_OBJ =       $(patsubst %.hts,$(SOURCE_DIR)/%.html,$(SOURCE_SRC))

M4_PREFS       = -Dm4_home=$(m4_home) -Dm4_dirname=$(m4_dirname) -Dm4_filename=$$X -Dm4_is_dos=$(IS_DOS)
M4_SHELL_PREFS = export m4_home=$(m4_home); export m4_dirname=$(m4_dirname); export WEBDATA=$(WEBDATA)
 
ifdef IS_DOS
EMACS = "c:/Program Files (x86)/emacs-23.1/bin/emacs.exe"
else
EMACS = emacs 
endif

m4: m5 m6 m7 
	make completed-build-m4

m5: m4-outer
#	@printf "TARGET_DIR=%s\n" $(TARGET_DIR)
#	mkdir -p $(TARGET_DIR)
#	cd $(SOURCE_DIR) && (for X in $(SOURCE_SRC_BASES); do (m4 -P $(M4_PREFS) $$X.hts >$(TARGET_DIR)/$$X.html); done)

m6:
#	@printf "$(TARGET_DIR_FILES)=%s\n" $(TARGET_DIR_FILES)
	for X in $(TARGET_DIR_FILES); do ((dos2unix -n $$X $$X.2) && (rm -fv $$X) && (mv -fv $$X.2 $$X)); done

m7:  
	(yes | $(EMACS) --batch --eval "(progn (setq ***dmp-play--game-over-sample*** nil)(setq ***dmp-yonkers*** \"~/Public/targets/50webs-com/$(m4_dirname)/\"))" --load ~/java-training-wheels/dlisp/scripts/dmp-purge-whitespace--string-from-htmls--file.el --funcall dmp-purge-whitespace--string-from-htmls--doit)

copy:
	mkdir -p $(TARGET_DIR)
	for X in $(wildcard *.pdf *.css *.gif *.gz *.htm *.html *.ico *.jpg *.js *.mpg *.pdf *.png *.zip); do cp -pv $$X $(TARGET_DIR); done

clean:
	mkdir -p $(TARGET_DIR)
	-cd $(TARGET_DIR); for X in *.gif *.jpg *.mpg *.zip *.gz *.html; do rm -vf $$X; done

html-quote-inner-emacs:
	-cp -fv $(DIR)/$(FILE) $(FILE)
	@printf "TARGET_DIR=%s FILE=%s\n" $(TARGET_DIR) $(FILE)
ifdef IS_LINUX
	$(M4_SHELL_PREFS); bash $(BIN)/e2html.bat $(FILE) >$(TARGET_DIR)/$(FILE).html
endif
ifdef IS_DOS
	$(M4_SHELL_PREFS); bash $(BIN)/e2html-dos.bat $(FILE) >$(TARGET_DIR)/$(FILE).html
endif
	make completed-website-make-m4

html-quote-cc-inner:
	cp $(DIR)/$(FILE) $(FILE)
	$(M4_SHELL_PREFS); bash $(BIN)/cc2html.bat $(FILE) >$(TARGET_DIR)/$(FILE).html
	rm $(FILE)

html-quote-el-inner:
#	cp $(DIR)/$(FILE) $(FILE)
	$(M4_SHELL_PREFS); bash $(BIN)/lisp2html.bat $(FILE) >$(TARGET_DIR)/$(FILE).html
#	rm $(FILE)

html-quote-el-inner-2:
	$(M4_SHELL_PREFS); bash $(BIN)/lisp2html.bat $(FILE) >$(TARGET_DIR)/$(FILE).html

html-quote-java-inner:
	cp $(DIR)/$(FILE) $(FILE)
	$(M4_SHELL_PREFS); bash $(BIN)/java2html.bat $(FILE) >$(TARGET_DIR)/$(FILE).html
	@printf "TARGET_DIR=%s FILE=%s\n" $(TARGET_DIR) $(FILE)
	rm $(FILE)

html-quote-html-inner:
	cp $(DIR)/$(FILE) $(FILE)
	$(M4_SHELL_PREFS); bash $(BIN)/html2html.bat $(FILE) >$(TARGET_DIR)/$(FILE).html
	rm $(FILE)

#html-quote-mk-inner:
#	 cp $(DIR)/$(FILE) $(FILE)
#	 $(M4_SHELL_PREFS); bash $(BIN)/makefile2html.bat $(FILE) >$(TARGET_DIR)/$(FILE).html
#	 rm $(FILE)

archive-inner:
	rm -vf $$(find $(DIR) -name "*.o")
	rm -vf $$(find $(DIR) -name "*.exe")
	rm -vf $$(find $(DIR) -name "*.tmp")
	rm -vf $$(find $(DIR) -name "*.class")
	rm -vf $$(find $(DIR) -name "*~")
	rm -vf $$(find $(DIR) -name "#*#")
	rm -vf $(DIR)/log*.txt
	tar cf $(FILE).tar $(DIR)
	gzip -f $(FILE).tar
	mv $(FILE).tar.gz $(TARGET_DIR)

#sedify:
#	 @printf "\n* MAKING SEDIFY WITH ARGS\n* SPLAT_RULE=%s\n* SPLAT_FILE_NAME=%s\n" $(SPLAT_RULE) $(SPLAT_FILE_NAME)
#	 sed -e '$(SPLAT_RULE)' $(SPLAT_FILE_NAME) >$(SPLAT_FILE_NAME).tmp
#	 mv $(SPLAT_FIL_NAME).tmp $(SPLAT_FILE_NAME)

DATESTAMP=$$(date +"%Y%m%d-%H%M%S")

ifdef IS_DOS

completed-website-make-tar: 
	emacs --batch --eval "(progn (setq file-to-play \"c:/sound-samples/emacs/completed-website-make-tar.wav\")(setq ***dmp-play--game-over-sample***))" --load c:/home/dlisp/dmp-safe--play-sound--file.el --funcall dmp-safe--play-sound--doit
 
completed-build-book: 
	emacs --batch --eval "(progn (setq file-to-play \"c:/sound-samples/emacs/completed-build-book.wav\")(setq ***dmp-play--game-over-sample*** nil))" --load c:/home/dlisp/dmp-safe--play-sound--file.el --funcall dmp-safe--play-sound--doit

completed-build-m4: 
#	@echo "Executing completed-build-m4 FRAZZLE!"
	-emacs --batch --eval "(progn (setq default-directory \"~/java-training-wheels/\")(setq **dmp-file--to-play** \"c:/sound-samples/emacs/completed-website-make-m4.wav\")(setq ***dmp-play--game-over-sample**** nil))" --load ~/java-training-wheels/dlisp/coolmacs/dmp-safe--play-sound--file.el --funcall dmp-safe--play-sound--doit

fcuk2:
	echo "bar2"

endif

ifdef IS_LINUX 

completed-website-make-tar:  
	emacs --batch --eval "(progn (setq ***dmp-play--game-over-sample*** nil)(setq *dmp-file--to-play* \"~/java-training-wheels/dlisp/sound-samples/emacs/gong.wav\"))" --load ~/java-training-wheels/dlisp/coolmacs/dmp-safe--play-sound--file.el --funcall dmp-safe--play-sound--doit

completed-build-book: 
	emacs --batch --eval "(progn (setq ***dmp-play--game-over-sample*** nil)(setq *dmp-file--to-play* \"~/java-training-wheels/dlisp/sound-samples/emacs/gong.wav\"))" --load ~/java-training-wheels/dlisp/coolmacs/dmp-safe--play-sound--file.el --funcall dmp-save--play-sound--doit

completed-build-m4:
	-emacs --batch --eval "(progn (setq ***dmp-play--game-over-sample*** nil)(setq default-directory \"~/java-training-wheels/\")(setq ***dmp-file--to-play*** \"~/java-training-wheels/dlisp/sound-samples/emacs/completed-website-make-m4.wav\"))" --load ~/java-training-wheels/dlisp/coolmacs/dmp-safe--play-sound--file.el --funcall dmp-safe--play-sound--doit

endif

m4-inner:
	echo Toadstool && m4 -P $(M4_PREFS) $(NAME).hts >$(TARGET_DIR)/$(NAME).html

m4-outer:
	-(for X in $(SOURCE_SRC_BASES); do (echo frog) && (make m4_dirname=$(m4_dirname) m4-inner NAME=$$X); done)

#(insert (buffer-name))
